var MessageCtrl = function () {

    var USER_ID , PREV = "message",
        USER_INFO = false,
        conversationCallBackId,
        callBackTime = 1000*10,
        OFFSET = {start : 0,last : 0};

    var TemplateMessages = function(){

        return {
            recentItems : function(){
                var data = MessageCtrl.storage_getRecentMessages();
                if(!data){
                    MessageCtrl.service_getRecentMessages(TemplateMessages.recentItems);
                }else{
                    var template = $("#template-message-list-item").html();

                    var listView = $('#listView_message_list');

                    listView.empty();

                    $.each(data,function(a,b){

                        var copy = template;

                        $.each(b,function(c,d){
                            if(c=="image"){
                                d = "<img src='"+img_get({"type":"profile_60","name":d})+"' />";
                            }
                            copy= copy.replace(new RegExp("{{"+c+"}}", 'g'),d?d:"");
                        });

                        var unread_badge = "";

                        if(b.m_type=="receive" && !b.m_received){
                            unread_badge = '<span class="badge-messaeg-unread"></span>';
                        }

                        if(b['m_received']){
                            //unread_badge = '<span class="badge-messaeg-unread"></span>';
                        }
                        copy= copy.replace(new RegExp("{{badge}}", 'g'),unread_badge);

                        listView.append("<li>"+copy+"</li>");
                    });

                }
            },

            chatItems : function(items){

                if(typeof items=="undefined"){
                    items = MessageCtrl.storage_getChat();
                }

                var template_sender = $('#template-chat-block-sender').html();
                var template_receiver = $('#template-chat-block-receiver').html();

                var container = $('#chat-container');

                var user_info = MessageCtrl.getUserInfo();

                $.each(items,function(a,b){

                    if(b['rid']==MessageCtrl.getUserId() || b['sid']==MessageCtrl.getUserId()){

                        $('[data-item-type="chat-message-item"][data-item-id="'+b['id']+'"]').remove();

                        var template ;

                        if(b['id'].length <11){
                            MessageCtrl.setOffset(b['id']);
                        }

                        if(b['sid']==ProfileCtrl.getUserId()){
                            template =  template_sender;
                            template = template.replace(new RegExp("{{image}}","g"),"<img src='"+IMAGE.getUrl('profile',ProfileCtrl.getUserProfile('user_image'),60)+"' />")
                                .replace(new RegExp("{{content}}","g"),b['content'])
                                .replace(new RegExp("{{id}}","g"),b['id'])
                                .replace(new RegExp("{{created}}","g"),DATE.getFromUnix(b['created'],"h:i d-M-Y"));

                        }else{
                            template =  template_receiver;
                            template = template.replace(new RegExp("{{image}}","g"),"<img src='"+IMAGE.getUrl('profile',user_info.image,60)+"' />")
                                .replace(new RegExp("{{content}}","g"),b['content'])
                                .replace(new RegExp("{{created}}","g"),DATE.getFromUnix(b['created'],"h:i d-M-Y"));
                        }

                        container.append(template);
                    }
                });
            },

            localItem : function(message){
                var b = {
                    id:new Date().getTime(),
                    sid:ProfileCtrl.getUserId(),
                    rid:MessageCtrl.getUserId(),
                    content:message,
                    created: new Date().getTime()/1000
                };
                TemplateMessages.chatItems([b]);
                return b.id ;
            }
        }
    }();

    return {

        getUserId: function () {return USER_ID;},
        setUserId: function (id) {return USER_ID = parseInt(id);},

        getUserInfo : function(){return USER_INFO;},
        setUserInfo : function(value){

            var value = {
                id : "",
                name : "",
                email : "",
                image : "",
                mobile_no : ""
            };


            if(MessageCtrl.getUserId()==2){
                value = {
                    id : "2",
                    name : "Live Support",
                    email : "support@indiakaapp.com",
                    image : "support.png",
                    mobile_no : "8769153956"
                };

                return USER_INFO = value;

            }

            if(MessageCtrl.getPrev()=="message"){
                var items = MessageCtrl.storage_getRecentMessages();
                for(var i=0;i<items.length;i++){
                    if(items[i]['id']==MessageCtrl.getUserId()){
                        value = {
                            id : items[i]['id'],
                            name : items[i]['name'],
                            email : items[i]['email'],
                            image : items[i]['image'],
                            mobile_no : items[i]['id']
                        };
                    }
                }
            }else{
                var item = MemberCtrl.storage_getMember(MessageCtrl.getUserId());
                if(item){
                    value = {
                        id : item.id,
                        name : item.name,
                        email : item.email,
                        image : item.image,
                        mobile_no : item.mobile_no
                    };
                }
            }

            return USER_INFO = value;
        },

        getPrev : function(){return PREV ;},
        setPrev : function(value){return PREV = value;},

        getOffset : function(){return OFFSET[MessageCtrl.getUserId()];},
        setOffset : function(value){

            if(!OFFSET.hasOwnProperty(MessageCtrl.getUserId())){
                OFFSET[MessageCtrl.getUserId()] = {start:"",last:""};
            }

            if(!OFFSET[MessageCtrl.getUserId()].start || OFFSET[MessageCtrl.getUserId()].start > value)
                OFFSET[MessageCtrl.getUserId()].start = value;

            if(!OFFSET[MessageCtrl.getUserId()].last || OFFSET[MessageCtrl.getUserId()].last < value)
                OFFSET[MessageCtrl.getUserId()].last = value;

            return OFFSET[MessageCtrl.getUserId()];

        },

        goToChat : function(id,from){
            MessageCtrl.setUserId(id);
            MessageCtrl.setPrev(from);
            $.mobile.changePage("#message_chat");
        },

        pageShowRecentMessages : function(event,ui,pageId){

            if(Application.getPageShow(pageId)==-1){
                MessageCtrl.refreshRecentMessages();
            }

            if(!Application.getPageShow(pageId)){
                TemplateMessages.recentItems();
            }
        },
        refreshRecentMessages : function(){
            MessageCtrl.service_getRecentMessages(TemplateMessages.recentItems);
        },

        pageShowChat : function(event,ui,pageId){

            var user = MessageCtrl.setUserInfo();

            Application.setPageTitle(pageId,user.name);

            $(".row-1.no-border .col-right").html("<img src='"+IMAGE.getUrl("profile",user.image,60)+"' />");


            TemplateMessages.chatItems();

            MessageCtrl.service_getChat();

            conversationCallBackId = setInterval(function(){
                if(Application.getActivePage()=="message_chat"){
                    MessageCtrl.service_getChat();
                }
            },callBackTime);

            $('#m_content').focus();
        },
        pageHideChat : function(event,ui,pageId){
            Application.setPageTitle(pageId,"");
            clearInterval(conversationCallBackId);
            Application.setPageShow("message_list",-1);

            $(".row-1.no-border .col-right").html("");
        },

        /* Storage */
        storage_setRecentMessages : function(data){
            return localStorage.setItem("MESSAGE_RECENT",JSON.stringify(data));
        },
        storage_getRecentMessages : function(){
            return JSON.parse(localStorage.getItem("MESSAGE_RECENT"));
        },
        storage_getChat : function(){
            var chat = JSON.parse(localStorage.getItem('MESSAGE_CHAT'));
            if(!chat)
                return [];

            if(chat.hasOwnProperty(MessageCtrl.getUserId())){
                return chat[MessageCtrl.getUserId()];
            }
            return [];
        },
        storage_addChat : function(item){

            var chat = JSON.parse(localStorage.getItem('MESSAGE_CHAT'));

            if(!chat)
                chat = {};

            if(!chat.hasOwnProperty(MessageCtrl.getUserId()))
                chat[MessageCtrl.getUserId()] = [];

            for(var i=0;i<item.length;i++){
                chat[MessageCtrl.getUserId()].push(item[i]);
            }

            return localStorage.setItem('MESSAGE_CHAT',JSON.stringify(chat));
        },


        /* Services */
        service_getRecentMessages : function(callBack){
            var success = function(response){
                if(response.status){
                    MessageCtrl.storage_setRecentMessages(response.data);
                    if(typeof callBack=="function"){
                        callBack();
                    }
                }
            };
            AJAX.call({
                url : {abs:"message/recent"},
                success:success,
                async:true
            });
        },
        service_getChat: function (){
            var success = function(response){
                if(response.status){
                    MessageCtrl.storage_addChat(response.data);
                    TemplateMessages.chatItems(response.data);
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url : {abs:"message/get/uid/"+MessageCtrl.getUserId()},
                async:true,
                beforeSend : function(){},
                data : MessageCtrl.getOffset(),
                success:success
            });
        },

        /* Send Message */
        onSend : function(inObject){

            var $form = $(inObject);

            var message_string = $.trim($('#m_content').val());

            if (message_string.length == 0) {
                return false;
            }

            var timestamp = TemplateMessages.localItem(message_string);

            var success = function(response){
                if(response.status){
                    $('[data-item-type="chat-message-item"][data-item-id="'+timestamp+'"]').attr("data-item-id",response.id);
                }else{
                    $('[data-item-type="chat-message-item"][data-item-id="'+timestamp+'"]').remove();
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url : {abs: $form.attr('action')+ "/user_id/"+MessageCtrl.getUserId()},
                data : $form.serialize(),
                beforeSend : function(){},
                async:true,
                success:success
            });

            $form.trigger('reset');

        }
    };
}();