var WallCtrl = function () {
    /* New Variables For Wall Controller */
    var EVENT_ID = false,
        GROUP_ID = false,
        SOCIETY_ID = false,
        MODULE = "society",
        MODULE_ID = false ,
        POST_ID = false ,
        FILTER = "all",
        AD_ID = false,
        NEWS_COUNTER = 0;
        GROUP_NEWS_COUNTER = 0;



    var OFFSETS = {
        "society" : {scroll:1000,start:0,last:0},
        "soshare" : {scroll:1000,start:0,last:0},
        "event" : {scroll:1000,start:0,last:0},
        "group" : {scroll:1000,start:0,last:0}
    };

    var getMemberRating = function(star){
        var html = "";
        for(var i=0;i<5;i++){
            if(i<star){
                html +="<i class='icon ion-ios-star'></i>";
            }else{
                html +="<i class='icon ion-ios-star-outline'></i>";
            }
        }
        return html;
    };

    /*
    * Wall Templates
    * Society Wall / Group Wall / Event Wall
    * Post Detail Page
    * */

    var TemplateWall = function(){
        return {

            items : function(data){

                var tile, pageId;

                if(typeof data=="undefined"){
                    data = WallCtrl.storage_getPosts(WallCtrl.getModule(),WallCtrl.getModuleId());
                }


                switch(WallCtrl.getModule()){
                    case "society" : pageId = "society_wall"; break;
                    case "soshare" : pageId = "soshare_wall"; break;
                    case "group" : pageId = "group_wall"; break;
                    case "event" : pageId = "event_wall"; break;
                    default :  pageId = Application.getActivePage();
                }

                var container = $("#"+pageId+" #"+pageId+"_content");


                $.each(data,function(key,data){

                    var tile = TemplateWall.item(data);

                    tile = tile.replace(new RegExp("{{regxIcon}}","g"),"fa-star");

                    var post_type_id = parseInt(data['statistics']['t_id']);

                   if(tile){

                        var tile_blocks;

                        if(WallCtrl.getModule()=="soshare"){
                            tile_blocks = $('[data-sos-post-id="'+data.statistics.id+'"]');
                        }else{
                            tile_blocks = $('[data-wall-post-id="'+data.statistics.id+'"]');
                        }


                        /* Replace Those who are already on DOM */
                        if(tile_blocks.length>0){
                            for(k=0;k<tile_blocks.length;k++){
                                var element = tile_blocks[k];
                                $(element).before(tile);
                                $(element).remove();
                                $(element).trigger('create');
                            }
                        }



                       if(WallCtrl.getModule()=="soshare"){
                           tile_blocks = $('#'+pageId+' [data-sos-post-id="'+data.statistics.id+'"]');
                       }else{
                           tile_blocks = $('#'+pageId+' [data-wall-post-id="'+data.statistics.id+'"]');
                       }

                       if(tile_blocks.length==0){

                           if(parseInt(data['statistics']['updated']) > WallCtrl.getLastPostId()){
                               container.prepend(tile);
                           }else{
                               container.append(tile);
                           }


                       }




                        WallCtrl.setOffset(data.statistics.updated);

                       tile_blocks.trigger('create');

                        if(post_type_id=="501"){

                            //$('.rate-neighbor-'+data.author.id).rateit();

                            $('.rate-neighbor-'+data.author.id).rateYo({
                                rating: 3.5,
                                numStars: 5,
                                precision: 0,
                                starWidth: "28px",
                                spacing: "2px",
                                //multiColor: {startColor: "#22B14C",endColor: "#269C49"},
                                onSet: function (rating){
                                    $('rate-neighbor-'+data.author.id).val(rating); //
                                    //$($(value).data('rating-id')).val(rating);
                                }
                            });

                        }
                    }
                });



                /* Display News */
                setTimeout(function(){
                    TemplateWall.itemNews();
                    $('#society_wall').trigger('create');
                },1000);
            },

            item : function(data){
                switch(data.statistics.t_id){
                    /*wall*/
                    case "1" :return TemplateWall.masterWall(data,TemplateWall.post(data));
                    case "2" :return TemplateWall.masterWall(data,TemplateWall.notice(data));
                    case "3" :return TemplateWall.masterWall(data,TemplateWall.event(data));
                    case "4" :return TemplateWall.masterWall(data,TemplateWall.survey(data));
                    case "5" :return TemplateWall.masterWall(data,TemplateWall.classified(data));


                    /*soShare*/
                    case "100" :return TemplateWall.masterSoShare(data,TemplateWall.classified(data));
                    case "101" :return TemplateWall.masterSoShare(data,TemplateWall.blood(data));
                    case "102" :return TemplateWall.masterSoShare(data,TemplateWall.carpool(data));
                    case "103" :return TemplateWall.masterSoShare(data,TemplateWall.neighBorrow(data));
                    case "104" :return TemplateWall.masterSoShare(data,TemplateWall.job(data));
                    case "105" :return TemplateWall.masterSoShare(data,TemplateWall.offer(data));
                    case "106" :return TemplateWall.masterSoShare(data,TemplateWall.matrimonial(data));
                    /*personal*/
                    case "501" :return TemplateWall.masterRating(data,TemplateWall.rating(data));
                    default : return "";
                }
            },

            masterWall : function(data,post_content){

                template = $('#template-wall-card-master').html(),

                  template =  template.replace(new RegExp("{{regx_POST_TYPE_BADGE}}","g"),"")
                    .replace(new RegExp("{{regx_POST_CONTENT}}","g"),post_content)
                    .replace(new RegExp("{{id}}","g"),data.statistics.id)
                    .replace(new RegExp("{{type_name}}","g"),data.statistics.t)
                    .replace(new RegExp("{{module}}","g"),WallCtrl.getModule())
                    .replace(new RegExp("{{author}}","g"),data.author.id)
                    .replace(new RegExp("{{class_like}}","g"),"like-"+data.statistics.is_like)
                    .replace(new RegExp("{{likes}}","g"),data.statistics.likes)
                    .replace(new RegExp("{{author_name}}","g"),data.author.name)
                    .replace(new RegExp("{{src}}","g"),"src='"+IMAGE.getUrl("profile",data.author.image,"60")+"'")
                    .replace(new RegExp("{{comments}}","g"),data.statistics.comments)
                    .replace(new RegExp("{{created}}","g"),DATE.getFromUnix(data.statistics.created,"d-M-Y"))
                    .replace(new RegExp("{{isLike}}","g"),data.statistics.is_like)
                    .replace(new RegExp("{{module_id}}","g"),WallCtrl.getModuleId());

                var prefix = WallCtrl.getModule();

                if(data.author.id==ProfileCtrl.getUserId()){
                    template = template.replace("{{post_more_class}}","").replace("{{more_popup_links}}","#"+prefix+"_action_list_author");
                }else if(ProfileCtrl.getUserSociety('role')=="admin"){
                    if(data.statistics.status=="active"){
                        template = template.replace("{{post_more_class}}","").replace("{{more_popup_links}}","#"+prefix+"_action_list_admin_block");
                    }else{
                        template = template.replace("{{post_more_class}}","").replace("{{more_popup_links}}","#"+prefix+"_action_list_admin_unblock");
                    }
                }else{
                    template = template.replace("{{post_more_class}}","").replace("{{more_popup_links}}","#"+prefix+"_action_list_user");
                }

                return template;

            },

            masterSoShare : function(data,post_content){

                var template = $('#template-sos-card-master').html();

                var txtLabelCenter = "";
                var labelClass = "";

                switch (data.statistics.t_id){
                     case "101": txtLabelCenter = "Blood Group "+data.post.type ;  labelClass = "fa fa-heartbeat"; break;
                     case "102": txtLabelCenter = data.post.date ;  labelClass = "icon fa ion-model-s"; break;
                     case "103": txtLabelCenter = data.post.category_name ; labelClass = "fa icon fa-share-square-o"; break;
                     case "104": txtLabelCenter = data.post.company_name ; labelClass = "icon fa ion-briefcase"; break;
                     case "105": txtLabelCenter = data.post.category_name ; labelClass = "fa icon fa-gift"; break;
                     case "106": txtLabelCenter = data.post.type+", Age "+data.post.age ; labelClass = "icon fa ion-ios-rose"; break;
                     case "501": txtLabelCenter = "Rate your neighbourhood" ; labelClass = "icon fa ion-star"; break;
                 }

                template =  template.replace(new RegExp("{{regx_POST_HEADER}}","g"),"")
                    .replace(new RegExp("{{regx_POST_TYPE_BADGE}}","g"),"")
                    .replace(new RegExp("{{regx_POST_CONTENT}}","g"),post_content)
                    .replace(new RegExp("{{regx_POSTEDBY}}","g"),"")
                    .replace(new RegExp("{{regx_POST_FOOTER}}","g"),"")
                    .replace(new RegExp("{{isJoined}}","g"),data.post.requested)
                    .replace(new RegExp("{{label_center}}","g"),txtLabelCenter)
                    .replace(new RegExp("{{classSosLabel}}","g"),labelClass)
                    .replace(new RegExp("{{id}}","g"),data.statistics.id)
                    .replace(new RegExp("{{type_name}}","g"),data.statistics.t)
                    .replace(new RegExp("{{src}}","g"),'src="'+IMAGE.getUrl('profile',data.author.image,160)+'"')
                    .replace(new RegExp("{{author}}","g"),data.author.id)
                    .replace(new RegExp("{{module}}","g"),WallCtrl.getModule())
                    .replace(new RegExp("{{module_id}}","g"),WallCtrl.getModuleId());

                return template;


            },

            masterRating : function(data,post_content){

                var template = $('#template-wall-card-master-rating').html();

                var txtLabelCenter = "";
                var labelClass = "";

                switch (data.statistics.t_id){
                     case "101": txtLabelCenter = data.post.type ;  labelClass = "fa fa-heartbeat"; break;
                     case "102": txtLabelCenter = data.post.date ;  labelClass = "icon fa ion-model-s"; break;
                     case "103": txtLabelCenter = data.post.category_name ; labelClass = "fa icon fa-gift"; break;
                     case "104": txtLabelCenter = data.post.company_name ; labelClass = "icon fa ion-briefcase"; break;
                     case "105": txtLabelCenter = data.post.category_name ; labelClass = "fa icon fa-gift"; break;
                     case "106": txtLabelCenter = data.post.type+", Age "+data.post.age ; labelClass = "icon fa ion-ios-rose"; break;
                     case "501": txtLabelCenter = "Rate your neighbourhood" ; labelClass = "icon fa ion-star"; break;
                 }

                template =  template.replace(new RegExp("{{regx_POST_HEADER}}","g"),"")
                    .replace(new RegExp("{{regx_POST_TYPE_BADGE}}","g"),"")
                    .replace(new RegExp("{{regx_POST_CONTENT}}","g"),post_content)
                    .replace(new RegExp("{{regx_POSTEDBY}}","g"),"")
                    .replace(new RegExp("{{regx_POST_FOOTER}}","g"),"")
                    .replace(new RegExp("{{label_center}}","g"),txtLabelCenter)
                    .replace(new RegExp("{{classSosLabel}}","g"),labelClass)
                    .replace(new RegExp("{{id}}","g"),data.statistics.id)
                    .replace(new RegExp("{{type_name}}","g"),data.statistics.t)
                    .replace(new RegExp("{{src}}","g"),'src="'+IMAGE.getUrl('profile',data.author.image,160)+'"')
                    .replace(new RegExp("{{author}}","g"),data.author.id)
                    .replace(new RegExp("{{module}}","g"),WallCtrl.getModule())
                    .replace(new RegExp("{{module_id}}","g"),WallCtrl.getModuleId());

                return template;


            },

            masterPersonal : function(data){

                var type = data.statistics.t_id ;

                var template = $('#template-wall-card-personal-master').html();

                var header ="";// _tile_header(type,data);


                var post = "";

                var badge;

                switch(type){
                    case "501" : badge= ""; post = TemplateWall.rating(data);break;
                    case "502" : badge= ""; post = _tile_personal_other(data); break;
                }


                template =  template.replace(new RegExp("{{regx_POST_HEADER}}","g"),header)
                    .replace(new RegExp("{{regx_POST_TYPE_BADGE}}","g"),badge)
                    .replace(new RegExp("{{regx_POST_CONTENT}}","g"),post)
                    .replace(new RegExp("{{regx_POSTEDBY}}","g"),footer)
                    .replace(new RegExp("{{regx_POST_FOOTER}}","g"),"")
                    .replace(new RegExp("{{type_name}}","g"),data.statistics.t_name)
                    .replace(new RegExp("{{author}}","g"),data.author.id)
                    .replace(new RegExp("{{post_id}}","g"),data.statistics.id)
                    .replace(new RegExp("{{id}}","g"),data.statistics.id)
                    .replace(new RegExp("{{module}}","g"),"personal")
                    .replace(new RegExp("{{module_id}}","g"),ProfileCtrl.getUserId());

                return template;


            },

            masterNews : function(){

                var pageId = "society_wall";

                var news = STORAGE.getNews();

                if(!news){
                    WallCtrl.refreshNews(TemplateWall.itemNews);
                    return ;
                }

                var wall_items = $("#"+pageId+" #society_wall_content [data-wall-post-id]");

                for(i=0;i<wall_items.length;i++){
                    var tile = wall_items[i];
                    if(news.length>NEWS_COUNTER){
                        $(tile).after(TemplateWall.news(news[NEWS_COUNTER]));
                    }
                    NEWS_COUNTER++;
                }

                while(news.length>NEWS_COUNTER){
                    $("#"+pageId+" #society_wall_content").append(TemplateWall.news(news[NEWS_COUNTER]));
                    NEWS_COUNTER++;
                }
            },

            itemNews : function(){

                if(!(Application.getActivePage()=="society_wall" || Application.getActivePage()=="group_wall"))
                    return ;


                var pageId = Application.getActivePage();

                var news ;
                var group = false;

                if(pageId=="society_wall"){
                    news = STORAGE.getNews();
                }else{
                    group = WallCtrl.storage_getGroup(WallCtrl.getGroupId());

                    if(!group)
                        return ;

                    news = STORAGE.getGroupNews(group.id);

                }

                if(!news){
                    if(pageId=="society_wall"){
                        WallCtrl.refreshNews(TemplateWall.itemNews);
                    }else{
                        WallCtrl.refreshGroupNews(TemplateWall.itemNews);
                    }
                    return ;
                }

                var wall_items;

                if(pageId=="society_wall"){
                    wall_items = $("#"+pageId+" #society_wall_content [data-wall-post-id]");
                }else{
                    wall_items = $("#"+pageId+" #group_wall_content [data-wall-post-id]");
                }

                var  newCounter;

                if(pageId!="society_wall"){
                   newCounter = GROUP_NEWS_COUNTER;
                }else{
                   newCounter = NEWS_COUNTER;
                }


                for(i=0;i<wall_items.length;i++){
                    var tile = wall_items[i];
                    if(news.length>newCounter){
                        $(tile).after(TemplateWall.news(news[newCounter]));
                    }
                    newCounter++;
                }

                while(news.length>newCounter){
                    if(pageId=="society_wall"){
                        $("#"+pageId+" #society_wall_content").append(TemplateWall.news(news[newCounter]));
                    }else{
                        $("#"+pageId+" #group_wall_content").append(TemplateWall.news(news[newCounter]));
                    }
                    newCounter++;
                }

                if(pageId=="society_wall"){
                    NEWS_COUNTER = newCounter;
                }else{
                    GROUP_NEWS_COUNTER = newCounter;
                }


            },

            news : function(data){

                var template = $('#template-wall-card-news-master').html();

                $.each(data,function(a,b){
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                return template;


            },

            post : function(data){

                var title = "", link = "";  image = "", video= "", status= "", template = $('#template-wall-card-wall-post').html();


                var html_link = function(linkContent){

                    if(!linkContent)
                        return "";

                    var template =  $('#template-wall-card-post-link').html()
                        .replace('{{title}}',linkContent.title)
                        .replace('{{description}}',linkContent.content)
                        .replace('{{src}}',"src='"+linkContent.images+"'");

                    if(linkContent.images=="img/default/user.png"){
                        template = template.replace("{{classExternal}}","hidden");
                    }

                    return "<div onclick='window.open(\""+linkContent.link+"\", \"_system\");' >"+template+"</div>";

                };

                var post_status = function(){

                    var dots = "";
                    if(data.post.description.length>100){
                        dots="...";
                    }

                    if(data.post.description){
                        if(data.post.link){
                            data.post.description = data.post.description.replace(data.post.link.link,"");
                        }
                    }


                    status = data.post.description ?
                    "<span><img src='img/icons/q-start.png' style='width:16px; margin: 6px 0 0px 6px !important ' /></span>" +
                    "<p class='status-text' style='padding: 8px; padding-right:24px;text-align: justify;line-height: 16px !important;max-height:74px;overflow: hidden;'>" +
                    ""+replaceURLWithHTMLLinks(nl2br(data.post.description))+dots+
                    "</p>" +"<span><img src='img/icons/q-end.png' style='width: 16px;margin:0px 6px 5px 0px !important; float: right;' /></span>":"";




                };

                var post_photo = function(){
                    if(data.post.description){
                        title = '<p class="wall-card-abs-heading">'+data.post.description.substr(0,120)+'</p>';
                    }
                    image = data.post.image ? "<img src='"+IMAGE.getUrl("wall",data.post.image)+"'>":"";
                };

                var post_video = function(){
                    title = '<p class="wall-card-abs-heading">'+data.post.description+'</p>';
                    video = data.post.attachment ? data.post.attachment : "";
                };

                if(data.post.image)
                     post_photo();
                else if(data.post.attachment)
                    post_video();
                else
                    post_status();



                template = template.replace(new RegExp("{{title}}","g"),title)
                                    .replace(new RegExp("{{image}}","g"),image)
                                    .replace(new RegExp("{{video}}","g"),video)
                                    .replace(new RegExp("{{link}}","g"),html_link(data.post.link))
                                    .replace(new RegExp("{{description}}","g"),status);



                return template;
            },

            event : function(data){

                var template = $('#template-wall-card-event').html();

                var format_event_time = function(date){

                    date = parseInt(date);

                    var time = DATE.getFromUnix(date,"h:i");
                    var day = DATE.getFromUnix(date,"d");
                    var month = DATE.getFromUnix(date,"M");
                    var year = DATE.getFromUnix(date,"Y");


                    var html = "<div>" +
                        "<table class='table-event-date'>" +
                        "<tr>" +
                        "<td class='event-day'>"+day+"</td>" +
                        "<td>" +
                        "<p class='event-month'>"+month+"</p>" +
                        "<p class='event-time'>"+time+"</p>" +
                        "</td>" +
                        "</tr>" +
                        "</table>" +
                        "</div>";

                    return html;

                };

                template = template.replace(new RegExp("{{title}}","g"),data.post.title)
                    .replace(new RegExp("{{image}}","g"),"<img src='"+IMAGE.getUrl("wall",data.post.image)+"'>")
                    .replace(new RegExp("{{description}}","g"),replaceURLWithHTMLLinks(data.post.description))
                    .replace(new RegExp("{{start}}","g"),format_event_time(data.post.start))
                    .replace(new RegExp("{{end}}","g"),data.post.end)
                    .replace(new RegExp("{{contact}}","g"),data.post.contact_details)
                    .replace(new RegExp("{{location}}","g"),data.post.location);
                return template;
            },

            survey : function(data){


                var _survey_attended = function(data){

                    var template = $('#template-wall-card-survey-attended').html();

                    var options = JSON.parse(data.post.options);
                    var ans = JSON.parse(data.post.survey_result);
                    var total_attend = parseInt(ans.total);
                    var form = "";
                    var index = 1;
                    $.each(options,function(a,b){
                        if(b!=""){
                            var percent =0;
                            if(total_attend){
                                percent = ans['vote_'+index]*100/total_attend;
                            }
                            percent = Math.round(percent);
                            form += '<label> '+index+'. '+b+' ('+percent+'%)</label>';
                            index++;
                        }
                    });

                    template = template.replace(new RegExp("{{question}}"),data.post.question)
                        .replace(new RegExp("{{total_attend}}"),total_attend)
                        .replace(new RegExp("{{survey_options}}"),form)
                        .replace(new RegExp("{{regxPostedBy}}"),"");

                    return template;
                };

                var _survey_new = function(data){

                    var template = $('#template-wall-card-survey-new').html();

                    var options = JSON.parse(data.post.options);

                    var form = "<form id='wall-survey-form-"+data.statistics.id+"' class='validate' data-survey-id ='"+data.statistics.id+"'  data-post-id='"+data.statistics.id+"' onsubmit='return WallCtrl.attendSurvey(this)'  >";

                    $.each(options,function(a,b){
                        if(b!=""){
                            if(data.post.type=="radio"){
                                form += '<label><input type="'+data.post.type+'" name="radio" value="'+a+'" data-mini="true"> '+b+' </label>';
                            }else{
                                form += '<label><input type="'+data.post.type+'" name="checkbox[]" value="'+a+'" data-mini="true"> '+b+' </label>';
                            }
                        }
                    });

                    form += '<button class="my-round-btn button-survey-submit" data-role="none" type="submit">Submit</button>' ;

                    template = template.replace(new RegExp("{{question}}"),data.post.question)
                        .replace(new RegExp("{{survey_options}}"),form)
                        .replace(new RegExp("{{regxPostedBy}}"),"");

                    return template;

                };

                if(data.post.survey_attend){
                    return  _survey_attended(data);
                }else{
                    return  _survey_new(data);
                }

            },

            classified : function(data){

                var template = $('#template-wall-card-classified').html();

                template = template.replace(new RegExp("{{title}}","g"),data.post.title)
                    .replace(new RegExp("{{price}}","g"),"")
                    .replace(new RegExp("{{category_name}}","g"),data.post.category_name)
                    .replace(new RegExp("{{image}}","g"),"<img src='"+IMAGE.getUrl('wall',data.post.image)+"' class='lazy' >")
                    .replace(new RegExp("{{description}}","g"),replaceURLWithHTMLLinks(data.post.description));

                return template;

            },

            blood : function(data){

                var template = $('#template-sos-card-blood').html();

                $.each(data.post,function(a,b){
                    //if(a=="message"){b = b.substring(0,40);}
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b);
                });

                return template;

            },

            carpool : function(data){

                var template = $('#template-sos-card-carpool').html();

                $.each(data.post, function (a, b) {
                    if (a == 'seat_share'){b = parseInt(data.post['seat_share']) - parseInt(data.post['seat_booked']) }
                    template = template.replace(new RegExp("{{" + a + "}}", "g"), b ? b : "-");
                });

                template = template.replace(new RegExp("{{source}}","g"), data.post.location.source.address);
                template = template.replace(new RegExp("{{destination}}","g"), data.post.location.destination.address);

                var icon = "";

                if(data.post.type=="2 Wheeler"){
                    icon = "fa-motorcycle";
                }else{
                    icon = "ion-model-s";
                }
                template = template.replace(new RegExp("{{regxIcon}}", "g"),icon);
                return template;


            },

            neighBorrow : function(data){

                var template = $('#template-sos-card-rent').html();

                $.each(data.post,function(a,b){
                    if(a=="image") b='<img src="'+IMAGE.getUrl('wall',b,160)+'"/>';
                    //if(a=="description") b=replaceURLWithHTMLLinks(b.substr(0,60));
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                return template;

            },

            job : function(data){
                var template = $('#template-sos-card-job').html();
                $.each(data.post,function(a,b){

                    if(a=="description") b = nl2br(replaceURLWithHTMLLinks(b.substr(0,140)))+"..";

                    if(a=="experience"){
                        if(b=="0"){
                            b="Fresher";
                        }else{
                            b = b+" Year";
                        }
                    }

                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });
                return template;
            },

            offer : function(data){

                var template = $('#template-sos-card-offer').html();

                $.each(data.post,function(a,b){
                    if(a=="image") b='<img src="'+IMAGE.getUrl('wall',b,160)+'"/>';
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                return template;

            },

            matrimonial : function(data){

                var template = $('#template-sos-card-matrimonial').html();

                $.each(data.post,function(a,b){
                    if(a=="image") b='<img src="'+IMAGE.getUrl('wall',b,160)+'"/>';
                    if(a=="description") b=replaceURLWithHTMLLinks(b);
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                return template;

            },

            rating : function(data){
                var template = $('#template-wall-card-neightbor-rating').html();
                template = template.replace(new RegExp("{{src}}","g"), 'src="'+IMAGE.getUrl('profile',data.author.image,160)+'"');
                template = template.replace(new RegExp("{{author_id}}","g"),data.author.id);
                template = template.replace(new RegExp("{{user_name}}","g"),data.author.name);
                return template;
            },

            ads : function(data){

                var template = $('#template-wall-card-post-detail').html();

                if(data.post.description){
                    if(data.post.link){
                        data.post.description = data.post.description.replace(data.post.link.link,"");
                    }
                }


                var title, description = data.post.description ? nl2br(data.post.description) : "";
                var video = data.post.attachment ? data.post.attachment : "";
                var image = data.post.image? "<img src='"+IMAGE.getUrl("wall",data.post.image,"thumb")+"'>" : "";

                if(image)title = "Photo";
                if(video) title = "Video";
                if(!image || !video) title = "Status";

                var slider = IMAGE.createGallery(data.post.gallery);

                if(slider.status){
                    image = slider.html;
                }

                if(!data.post.image){
                    image = "";
                }

                Application.setPageTitle("society_wall_detail",title);

                var html_link = function(linkContent){

                    if(!linkContent)
                        return "";


                    var template =  $('#template-wall-card-post-link').html()
                        .replace('{{title}}',linkContent.title)
                        .replace('{{description}}',linkContent.content)
                        .replace('{{src}}', 'src="'+linkContent.images+'"');

                    if(linkContent.images=="img/default/user.png"){
                        template = template.replace("{{classExternal}}","hidden");
                    }

                    return "<div onclick='window.open(\""+linkContent.link+"\", \"_system\");' >"+template+"</div>";

                };

                if(description)
                    description = replaceURLWithHTMLLinks(description);

                /*var images = JSON.parse(data.post.description);

                 if(images && typeof images=="object"){
                 for(k=1;k<images.length;k++){
                 description += "<img src='img/default/default.png' class='lazy'  data-src='"+img_get({type:"wall_thumb",name:images[k]})+"'><br>";
                 }
                 }*/

                template = template.replace(new RegExp("{{image}}","g"),image)
                    .replace(new RegExp("{{video}}","g"),video)
                    .replace(new RegExp("{{link}}","g"),html_link(data.post.link))
                    .replace(new RegExp("{{description}}","g"),description);


                var outObject = {html : template,extra:{}};

                if(slider.status){
                    outObject.extra.slider = {time : slider.time};
                }

                return outObject;


            },

            showEventInfo : function(){

                var pageId = "society_event_information";

                var data = WallCtrl.storage_getPost(WallCtrl.getPostId());


                Application.setPageTitle("society_event_information",data.post.title);


                var footer = $('#template-footer-control-sos').html();


                if(data.author.id==ProfileCtrl.getUserId()){
                    footer = footer.replace("{{onClick}}","WallCtrl.eventAction("+WallCtrl.getEventId()+",'left')")
                        .replace("{{class}}","fc-b")
                        .replace("{{label}}","Exit Event");
                }else{
                    if(data.post.joined){
                        footer = footer.replace("{{onClick}}","WallCtrl.eventAction("+WallCtrl.getEventId()+",'left')")
                            .replace("{{class}}","fc-a")
                            .replace("{{label}}","Exit Event");
                    }else{
                        footer = footer.replace("{{onClick}}","WallCtrl.eventAction("+WallCtrl.getEventId()+",'join')")
                            .replace("{{class}}","fc-submit")
                            .replace("{{label}}","Join");
                    }
                }


                $('#society_event_information').append(footer);


                $('#society_event_information').trigger("create");


                var template = $('#template-event-information').html();

                var format_event_time = function(date){

                    var day = date.substr(9,2);
                    var time = date.substr(0,8);
                    var month = date.substr(12,3);
                    var year = date.substr(16,4);


                    var html = "<div>" +
                        "<table class='table-event-date'>" +
                        "<tr>" +
                        "<td class='event-day'>"+day+"</td>" +
                        "<td>" +
                        "<p class='event-month'>"+month+"</p>" +
                        "<p class='event-time'>"+time+"</p>" +
                        "</td>" +
                        "</tr>" +
                        "</table>" +
                        "</div>";

                    return html;

                };

                var slider = IMAGE.createGallery(data.post.gallery);


                template = template.replace(new RegExp("{{title}}","g"),data.post.title)
                    .replace(new RegExp("{{gallery_html}}","g"),slider.html)
                    .replace(new RegExp("{{description}}","g"),replaceURLWithHTMLLinks(data.post.description))
                    .replace(new RegExp("{{start_time}}","g"),DATE.getFromUnix(data.post.start,"h:i A"))
                    .replace(new RegExp("{{end_time}}","g"),DATE.getFromUnix(data.post.end,"h:i A"))
                    .replace(new RegExp("{{start_date}}","g"),DATE.getFromUnix(data.post.start,"d-M-Y"))
                    .replace(new RegExp("{{end_date}}","g"),DATE.getFromUnix(data.post.end,"d-M-Y"))
                    .replace(new RegExp("{{contact}}","g"),data.post.contact)
                    .replace(new RegExp("{{location}}","g"),data.post.location);

                $("#society_event_information .page-working-wrapper").html(template);

                IMAGE.initSwiper({time:slider.time});


                var success = function (response) {
                    if (response.status){
                        /* Update Post Data to Table */
                        var postDetails = {
                            author : response.data.author,
                            post : response.data.post,
                            statistics : response.data.statistics
                        };

                        WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),WallCtrl.getPostId(),new Array(postDetails));

                        var members = response.data.event_members;

                        var template_group_members = '<div class="list">' +
                            '<div class="ionic">' +
                            '<h3 style="font-size: 13px;">' +
                            'Event Members</h3>' +
                            '{{regx_MEMBERS}}</div>' +
                            '</div>';

                        list = "";

                        list +="<ul class='list'>";

                        for(i=0;i<members.length;i++){
                            var member = members[i];

                            var member_template = $('#template-event-member-item').html();

                            member_template = member_template.replace("{{src}}","src='"+IMAGE.getUrl("profile",member['image'],60)+"'")
                                .replace("{{name}}",member.name?member.name:member.email)
                                .replace("{{star}}",getMemberRating(member.rating?member.rating:0));

                            list += member_template;
                        }
                        list +="</ul>";

                        $("#society_event_information .event-info-members").html(list);

                    }else{
                        Notification.toast({message:response.message,alert:true});
                        WallCtrl.removePost(WallCtrl.getPostId());
                        Application.back();
                    }
                };

                AJAX.call({
                    url: {abs: "wall/getpostdetail"},
                    data : {
                        wmodule : WallCtrl.getModule(),
                        wmodule_id : WallCtrl.getModuleId(),
                        pid : WallCtrl.getPostId()
                    },
                    success: success,
                    async:true
                });


            },

            showGroupInfo : function(){

                var pageId = "society_group_information";

                var data = WallCtrl.storage_getGroup(WallCtrl.getGroupId());

                /* var header footer  */
                Application.setPageTitle("society_group_information",data.name);

                var footer = $('#template-footer-control-sos').html();


                if(data.uid==ProfileCtrl.getUserId()){
                    footer = footer.replace("{{onClick}}","WallCtrl.groupAction("+WallCtrl.getGroupId()+",'left')")
                        .replace("{{class}}","fc-b")
                        .replace("{{label}}","Exit Group");
                }else{
                    if(data.gm_id){
                        /* Joined >> Show Exit Event*/
                        footer = footer.replace("{{onClick}}","WallCtrl.groupAction("+WallCtrl.getGroupId()+",'left')")
                            .replace("{{class}}","fc-b")
                            .replace("{{label}}","Exit Group");
                    }else{
                        /* Joined >> Show Join Event*/
                        footer = footer.replace("{{onClick}}","WallCtrl.groupAction("+WallCtrl.getGroupId()+",'join')")
                            .replace("{{class}}","fc-submit")
                            .replace("{{label}}","Join");
                    }
                }

                $('#society_group_information').append(footer);
                $('#society_group_information').trigger("create");


                var template = $('#template-group-information').html();

                var slider = IMAGE.createGallery(data.images);




                template = template.replace(new RegExp("{{title}}","g"),data.name)
                    .replace(new RegExp("{{description}}","g"),replaceURLWithHTMLLinks(data.description))
                    .replace(new RegExp("{{gallery_html}}","g"),slider.html)
                    .replace(new RegExp("{{location}}","g"),data.description);


                $("#society_group_information .data-content-working").html(template);


                IMAGE.initSwiper({time:slider.time});

                var success = function (response) {
                    if (response.status){


                        var members = response.data.members;

                        var template_group_members = '<div class="list">' +
                            '<div class="ionic">' +
                            '<h3 style="font-size: 13px;">' +
                            'Group Members</h3>' +
                            '{{regx_MEMBERS}}</div>' +
                            '</div>';

                        list = "";

                        list +="<ul class='list'>";

                        for(i=0;i<members.length;i++){
                            var member = members[i];

                            var member_template = $('#template-event-member-item').html();

                            member_template = member_template.replace("{{src}}","src='"+IMAGE.getUrl("profile",member['u_image'],60)+"'")
                                .replace("{{name}}",member.u_name?member.u_name:member.u_email)
                                .replace("{{star}}",getMemberRating(member.u_rating?member.u_rating:0));

                            list += member_template;
                        }
                        list +="</ul>";

                        $("#society_group_information .event-info-members").html(list);

                    }else{
                        Notification.toast({message:response.message,alert:true});
                        WallCtrl.removePost(WallCtrl.getPostId());
                        Application.back();
                    }
                };

                AJAX.call({
                    url: {abs: "wall/getgroupdetails"},
                    data : {
                        wmodule : WallCtrl.getModule(),
                        wmodule_id : WallCtrl.getModuleId(),
                        gid : WallCtrl.getGroupId(),
                    },
                    success: success,
                    async:true
                });
                $('#'+pageId).trigger('create');
            },

            detailPage : function(id,likeComments){

                TemplateWall.detailPageHeader(id);

                TemplateWall.detailPageFooter(id);


                var post = WallCtrl.storage_getPost(id), sos_post = false,

                    detail_html = "",detail_extra = {},post_details ="",

                    pageSelector = "#society_wall_detail .data-content-working",
                    pageId = "society_wall_detail",
                    template = $("#template-master-wall-detail").html();

                var post_type_id = post['statistics']['t_id'];


                $(pageSelector).html(template).trigger('create');

                switch(post_type_id){
                    case "1": post_details = TemplateWall.statusDetails(post); break;
                    case "2": post_details = TemplateWall.eventDetails(post);break;
                    case "3": post_details = TemplateWall.eventDetails(post);break;
                    case "4": post_details = TemplateWall.surveyDetails(post);break;
                    case "5": post_details = TemplateWall.classifiedDetails(post);break;/* Wall Post */

                    case "101" : post_details = TemplateWall.bloodDetails(post);break;
                    case "102" : post_details = TemplateWall.carpoolDetails(post);break;
                    case "103" : post_details = TemplateWall.neighBorrowDetails(post);break;
                    case "104" : post_details = TemplateWall.jobDetails(post);break;
                    case "105" : post_details = TemplateWall.offerDetails(post);break;
                    case "106" : post_details = TemplateWall.matrimonialDetails(post);break;
                }


                if(typeof post_details =="object"){
                    detail_html = post_details.html;
                    detail_extra = post_details.extra;
                }else{
                    detail_html = post_details;
                }


                if(post_type_id!="102"){

                    detail_html = detail_html.replace("{{regxPostedBy}}",TemplateWall.detailPostedBy(id));

                    $('#society_wall_detail .post-detail-area').html(detail_html);


                    if(detail_extra.hasOwnProperty('slider') && detail_extra.slider){
                        var time = detail_extra.slider.time;
                        IMAGE.initSwiper({time:time});
                    }
                }





                /*  Request Server for Likes and Comments  */
                if(typeof likeComments=="undefined"){
                    WallCtrl.service_getWallPostDetail(TemplateWall.detailLikeComments);
                }else{
                    TemplateWall.detailLikeComments(likeComments);
                }
            },

            detailPageHeader : function(id){

                var post = WallCtrl.storage_getPost(id);

                var title = post.statistics.t;

                switch(post.statistics.t_id){
                    case "1": title = "Post Details"; break;
                    case "2": title = "Notice Details"; break;
                    case "3": title = "Event Details"; break;
                    case "4": title = "Survey Details"; break;
                    case "5": title = "Classified Details"; break;

                    case "101": title += " For "+ post.post.type; break;
                    case "102": title = "Carpool Offer Details"; break;
                    case "103": title = post.post.category_name; break;
                    case "104": title = "Job - Details"; break;
                    case "105": title = "Offer for "+post.post.category_name; break;
                    case "106": title = "Matrimonial Information"; break;

                }
                Application.setPageTitle('society_wall_detail',title);

            },

            detailPageFooter : function(id){

                var data = WallCtrl.storage_getPost(id);


                var isFooterShow = true;
                var txtLabel = "Join";
                var txtTitle = "";
                var footer = $('#template-footer-control-sos').html();

                switch(data.statistics.t_id){
                    case "101" : txtLabel = "Donate"; txtTitle = data.post.type ; break;
                    case "102" : txtTitle = "Car Pool" ;  break;
                    case "103" : txtTitle =  data.post.title ;  break;
                    case "104" : txtTitle = "Job";  break;
                    case "105" : txtTitle = "Matrimonial" ;  break;
                    case "106" : txtTitle = "Matrimonial" ;  break;
                }



                /* if Owner is logged In */



                if(data.author.id==ProfileCtrl.getUserId()){

                    if(data.statistics.ref_status=="active"){
                        footer = footer.replace("{{onClick}}","WallCtrl.sosPostAction("+WallCtrl.getPostId()+",'close')")
                            .replace("{{class}}","fc-b")
                            .replace("{{label}}","Close");
                    }else{
                        footer = footer.replace("{{onClick}}","WallCtrl.sosPostAction("+WallCtrl.getPostId()+",'delete')")
                            .replace("{{class}}","fc-b")
                            .replace("{{label}}","Delete");
                    }
                }else if(data.statistics.ref_status=="active"){
                    if(data.post.requested){/* Requested By The User */
                        footer = footer.replace("{{onClick}}","WallCtrl.sosPostAction("+WallCtrl.getPostId()+",'left')")
                            .replace("{{class}}","fc-b")
                            .replace("{{label}}","Exit");
                    }else{/* Not Yet Requested */
                        footer = footer.replace("{{onClick}}","WallCtrl.sosPostAction("+WallCtrl.getPostId()+",'join')")
                            .replace("{{class}}","fc-submit")
                            .replace("{{label}}",data.statistics.t_id=="104"?"Apply":"Join");
                    }
                }else{
                    isFooterShow = false;
                }


                if(isFooterShow){
                    $('#society_wall_detail').append(footer);
                    $('#society_wall_detail').trigger("create");
                }

            },

            detailPostedBy : function(id){
                var data = WallCtrl.storage_getPost(id);
                var template = $("#template-detail-posted-by").html().replace(new RegExp("{{name}}","g"),data.author.name)
                    .replace(new RegExp("{{src}}","g"),"src='"+IMAGE.getUrl("profile",data.author.image,"60")+"'")
                    .replace(new RegExp("{{created}}","g"),DATE.getFromUnix(data.statistics.created,"h:i d-M-Y"));
                $('#society_wall_detail .post-detail-posted-by').append(template);
            },

            detailLikeComments : function(data){

                var type_id = parseInt(data.statistics.t_id);

                var showLikes = function(likes){
                    var container = $('#society_wall_detail .post-likes-container .list-user-thumb');
                    container.empty();
                    for(i=0;i<likes.length;i++){
                        if(i==0)
                            $('#society_wall_detail .post-likes-container').prepend('<h3 class="heading">Who Likes ('+likes.length+')</h3>');

                        var like = likes[i];
                        container.append("<li><img src='"+IMAGE.getUrl("profile",like['image'])+"' /></li>");
                    }
                };

                var showComments = function(comments){
                    var container;

                    if(Application.getActivePage()=="advertisement_detail"){
                        container = $('#advertisement_detail .post-comments-container .list-comment');
                    }else{
                        container = $('#society_wall_detail .post-comments-container .list-comment');
                    }


                    container.html("");

                    for(var i= 0,comment;comment= comments[i];i++){
                        var template = $('#template-comment-item').html();
                        var control = "";

                        $.each(comment,function(c,d){
                            if(c=="image") d = "<img src='"+IMAGE.getUrl("profile",d,"60")+"'>"
                            if(c=="date") d = DATE.getFromUnix(d,"d-M-Y");
                            template = template.replace(new RegExp("{{"+c+"}}","g"),d);
                        });

                        if(comment['uid']==ProfileCtrl.getUserId() || ProfileCtrl.getUserSociety('role')=="admin")
                            control = "<button data-role='none' onclick='WallCtrl.handlerDeletePostComment("+comment['id']+")'>remove</button>";

                        template = template.replace(new RegExp("{{regxControl}}","g"),control);

                        container.append(template);
                    }

                    $("#society_wall_detail .post-comments-container .item-post-comment").attr("data-item-post-id",WallCtrl.getPostId());

                };

                var showSosRequests = function(data){

                    var requests = data.requests;
                    var selector = "#society_wall_detail .post-detail-sos-requests";
                    var container = $(selector);

                    for(var i= 0,request; request = requests[i];i++){

                        var btn_accept = '<a href="javascript:void(0)" class="btn-sos sos-accept" onclick="WallCtrl.sosRequestAction('+request.id+',\'accept\')"><i class="fa icon ion-checkmark"></i> Accept</a>',
                            btn_reject = '<a href="javascript:void(0)" class="btn-sos sos-reject" onclick="WallCtrl.sosRequestAction('+request.id+',\'reject\')"><i class="fa icon ion-close-circled"></i> Reject</a>',
                            btn_chat = '<a href="javascript:void(0)" class="btn-sos sos-chat" onclick="MessageCtrl.goToChat('+request.u_id+',\'society_wall_detail\')"><i class="fa icon ion-chatbubbles"></i> Chat</a>';

                        var control = "";

                        if(request.status=="accepted"){
                            request.u_name += ' <a href="javascript:void(0)" class="btn-sos sos-accept"> <i class="fa icon ion-checkmark"></i></a>';
                            control = btn_chat;
                        }else if(request.status=="rejected"){
                            request.u_name += ' <a href="javascript:void(0)" class="btn-sos sos-reject"> <i class="fa icon ion-checkmark"></i></a>';
                            control = btn_chat;
                        }else{
                            control = btn_accept+" "+btn_reject+" "+btn_chat;
                        }

                        var template = $("#template-soShare-request-item").html();
                        template = template.replace("{{name}}",request.u_name)
                        template = template.replace("{{src}}","src='"+IMAGE.getUrl("profile",request.u_image,"60")+"'")
                            .replace("{{created}}",DATE.getFromUnix(request.updated,"d-M-Y"))
                            .replace("{{control}}",control);
                        container.append(template);
                    }
                };

                if(data.hasOwnProperty('likes'))
                    showLikes(data['likes']);

                if(data.hasOwnProperty('comments'))
                    showComments(data['comments']);

                if(data.hasOwnProperty('requests') &&  data.author.id == ProfileCtrl.getUserId() &&  type_id >= 100 && type_id<200)
                    showSosRequests(data);
            },

            statusDetails : function(data){

                var template = $('#template-wall-card-post-detail').html();


                if(data.post.description){
                    if(data.post.link){
                        data.post.description = data.post.description.replace(data.post.link.link,"");
                    }
                }


                var title, description = data.post.description ?
                "<p class='status-text' style='margin: 6px 0 0 0;font-size: 14px;line-height:18px;font-weight:400;text-align: justify;'><span>" +
                "<img src='img/icons/q-start.png' style='width:16px;margin: 0 6px 2px 6px;' /></span>" +
                ""+nl2br(data.post.description)+"<span><img src='img/icons/q-end.png' style='width:16px;margin:0px 0px 0 6px;' />" +
                "</span></p>":"";
                var video = data.post.attachment ? data.post.attachment : "";
                var image = data.post.image? "<img src='"+IMAGE.getUrl("wall",data.post.image,"thumb")+"'>" : "";

                if(image)title = "Photo";
                if(video) title = "Video";
                if(!image || !video) title = "Status";

                var slider = IMAGE.createGallery(data.post.gallery);

                if(slider.status){
                    image = slider.html;
                }

                if(!data.post.image){
                    image = "";
                }

                var html_link = function(linkContent){

                    if(!linkContent)
                        return "";

                    var template =  $('#template-wall-card-post-link').html()
                        .replace('{{title}}',linkContent.title)
                        .replace('{{description}}',linkContent.content)
                        .replace('{{src}}',"src='"+linkContent.images+"'");

                    if(linkContent.images=="img/default/user.png"){
                        template = template.replace("{{classExternal}}","hidden");
                    }

                    return "<div onclick='window.open(\""+linkContent.link+"\", \"_system\");' >"+template+"</div>";

                };


                Application.setPageTitle("society_wall_detail",title);

                if(description)
                    description = replaceURLWithHTMLLinks(description);

                /*var images = JSON.parse(data.post.description);

                if(images && typeof images=="object"){
                    for(k=1;k<images.length;k++){
                        description += "<img src='img/default/default.png' class='lazy'  data-src='"+img_get({type:"wall_thumb",name:images[k]})+"'><br>";
                    }
                }*/

                template = template.replace(new RegExp("{{image}}","g"),image)
                    .replace(new RegExp("{{video}}","g"),video)
                    .replace(new RegExp("{{link}}","g"),html_link(data.post.link))
                    .replace(new RegExp("{{description}}","g"),description);


                var outObject = {html : template,extra:{}};

                if(slider.status){
                    outObject.extra.slider = {time : slider.time};
                }

                return outObject;

            },

            eventDetails : function(data){


            },

            surveyDetails : function(data){

                if(data['post']['question']){
                    Application.setPageTitle("society_wall_detail",data['post']['question']);
                }
                return TemplateWall.item(data);
            },

            classifiedDetails : function(data){
                Application.setPageTitle("society_wall_detail",data.post.title);
                var template = $('#template-wall-card-classified-details').html();

                var slider = IMAGE.createGallery(data.post.gallery);

                template = template.replace(new RegExp("{{title}}","g"),data.post.title)
                    .replace(new RegExp("{{category_name}}","g"),data.post.category_name)
                    .replace(new RegExp("{{price}}","g"),data.post.price)
                    .replace(new RegExp("{{gallery_html}}","g"),slider.html)
                    //.replace(new RegExp("{{image}}","g"),"<img src='"+IMAGE.getUrl("wall",data.post.image,"thumb")+"'>")
                    .replace(new RegExp("{{description}}","g"),data.post.description);

                var outObject = {html : template,extra:{}};

                if(slider.status){
                    outObject.extra.slider = {time : slider.time};
                }

                return outObject;
            },

            bloodDetails : function(data){
                var template = $('#template-sos-blood-details').html();
                $.each(data.post,function(a,b){
                    if(a=="message"){b = b.substring(0,40);}
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b);
                });
                template  = template.replace("{{name}}",data.author.name);
                return template;

            },

            carpoolDetails : function(data){

                var template = $('#template-sos-carpool-detail').html();

                var origin = {
                    address : data.post.location.source.address,
                    latitude:data.post.location.source.lat,
                    longitude:data.post.location.source.lng
                };

                var destination = {
                    address : data.post.location.destination.address,
                    latitude:data.post.location.destination.lat,
                    longitude:data.post.location.destination.lng
                };

                template = template.replace(new RegExp("{{source}}", "g"),origin.address).replace(new RegExp("{{destination}}", "g"),destination.address);

                $.each(data.post, function (a, b) {
                    if (a == 'seat_share'){b = parseInt(data.post['seat_share']) - parseInt(data.post['seat_booked']) }
                    template = template.replace(new RegExp("{{" + a + "}}", "g"), b ? b : "-");
                });

                var icon = "";
                if(data.post.type=="2 Wheeler"){
                    icon = "fa-motorcycle";
                }else{
                    icon = "ion-model-s";
                }

                template = template.replace(new RegExp("{{regxIcon}}", "g"),icon);
                template = template.replace(new RegExp("{{status}}", "g"),"Open");




                $('#society_wall_detail .post-detail-area').html(template).trigger('create');


                var directionsService = new google.maps.DirectionsService();
                var directionsDisplay = new google.maps.DirectionsRenderer();

                var map ;


                var mapContainer = $('#society_wall_detail #map-canvas-carpool');
                var directionContainer = $('#society_wall_detail #map-direction-carpool');


                map = new google.maps.Map(mapContainer[0],{
                    center: new google.maps.LatLng(origin.latitude,origin.longitude),
                    zoom: 15,
                    draggableCursor:false,
                    disableDefaultUI:true
                });


                directionsDisplay.setMap(map);

                directionsDisplay.setPanel(directionContainer[0]);

                var request = {
                    origin : new google.maps.LatLng(origin.latitude,origin.longitude),
                    destination:  new google.maps.LatLng(destination.latitude,destination.longitude),
                    travelMode: google.maps.DirectionsTravelMode.DRIVING,
                };

                directionsService.route(request, function(response, status) {
                    if (status == google.maps.DirectionsStatus.OK) {
                        directionsDisplay.setDirections(response);
                    }
                });

                return template;

            },

            neighBorrowDetails : function(data){

                var template = $('#template-wall-card-neighBorrow-details').html();

                $.each(data.post,function(a,b){
                    if(a=="description") b=replaceURLWithHTMLLinks(b);
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                var slider = IMAGE.createGallery(data.post.gallery);

                template = template.replace(new RegExp("{{gallery_html}}","g"),slider.html);

                var outObject = {html : template,extra:{}};

                if(slider.status){
                    outObject.extra.slider = {time : slider.time};
                }

                return outObject;
            },

            jobDetails : function(data){

                var template = $('#template-sos-card-job-details').html();

                $.each(data.post,function(a,b){
                    if(a=="image") b='<img src="'+IMAGE.getUrl('wall',b,"thumb")+'"/>';
                    if(a=="description") b=replaceURLWithHTMLLinks(b);
                    if(a=="experience"){
                        if(b=="0"){
                            b="Fresher";
                        }else{
                            b = b+" Year";
                        }
                    }
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                return template;
            },

            offerDetails : function(data){

                var template = $('#template-wall-card-neighBorrow-details').html();

                $.each(data.post,function(a,b){
                    if(a=="description") b=replaceURLWithHTMLLinks(b);
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                var slider = IMAGE.createGallery(data.post.gallery);

                template = template.replace(new RegExp("{{gallery_html}}","g"),slider.html);

                var outObject = {html : template,extra:{}};

                if(slider.status){
                    outObject.extra.slider = {time : slider.time};
                }

                return outObject;
            },

            matrimonialDetails : function(data){

                var template = $('#template-wall-card-matrimonial-details').html();

                $.each(data.post,function(a,b){
                    if(a=="description") b=replaceURLWithHTMLLinks(b);
                    template = template.replace(new RegExp("{{"+a+"}}","g"),b?b:"");
                });

                var slider = IMAGE.createGallery(data.post.gallery);

                template = template.replace(new RegExp("{{gallery_html}}","g"),slider.html);

                var outObject = {html : template,extra:{}};

                if(slider.status){
                    outObject.extra.slider = {time : slider.time};
                }
                return outObject;

            },




      }
    }();


    var TemplateAds = function(){
        return {
            item : function(data){

                var pageId = "advertisement_detail";


                var html = function(template){



                    //template = template.replace("{{regx_MEMBERS}}", TemplateWall.detailLikeComments(data));

                    var html_options = function(){
                        var options = data.post.options;

                        var html = "";

                        $.each(options,function(oKey,oValue){

                            var template = $('#template-wall-ad-rating-option').html();

                            template = template.replace(new RegExp("{{label}}","g"),oValue)
                                        .replace(new RegExp("{{key}}","g"),oKey);
                            html +=template;

                        });
                        return html;
                    };

                    template = template.replace(new RegExp("{{ratingOptions}}","g"),html_options());


                    $(Application.getPageContainer(pageId)).html(template).trigger('create');


                    $("#"+pageId+" #frm_submit_ad_review").validate({
                        submitHandler: function (form){WallCtrl.onSubmitAdReview(form);}
                    });


                    var post_details = TemplateWall.ads(data);


                    if(typeof post_details =="object"){
                        detail_html = post_details.html;
                        detail_extra = post_details.extra;
                    }else{
                        detail_html = post_details;
                    }



                    Application.setPageTitle(pageId,data.post.description);

                    WallCtrl.setAdvertisementId(data.statistics.id);

                    detail_html = detail_html.replace("{{regxPostedBy}}",""); //_tile_detail_page_posted_by(data)



                    $('#advertisement_detail .post-detail-area').html(detail_html);



                    if(typeof post_details=="object"){
                        if(detail_extra.hasOwnProperty('slider') && detail_extra.slider){
                            var time = detail_extra.slider.time;
                            IMAGE.initSwiper({time:time});
                        }

                    }


                    $('.rate-user-ans-star').each(function(index,value){
                        $(value).rateYo({
                            rating:0,
                            numStars: 5,
                            precision: 0,
                            starWidth: "24px",
                            spacing: "0px",
                            //multiColor: {startColor: "#22B14C",endColor: "#269C49"},
                            onSet: function (rating){$($(value).data('rateit-backingfld')).val(rating);}
                        });
                    });

                    TemplateWall.detailLikeComments(data);



                    if(data.post.type_name=="Post") {

                    }


                    var footer_template = $('#template-footer-ads-review').html();

                    $('#'+pageId).append(footer_template).trigger('create');





                };


                $.ajax({
                    url : "js/MVC/View/wall/advertisement_detail.html",
                    async : false ,
                    cache : false,
                    success : html
                });
            }
        };
    }();

    /*
    * Groups and Related Templates
    * */
    var TemplateGroup = function(){
        return {

            itemJoined : function(){

                var data = WallCtrl.storage_getGroups(),
                    template = $('#template-group-listing-item').html(),
                    listView = $("#listView_group_joined");

                if(!data){
                    WallCtrl.refreshGroupJoined();
                    return ;
                }

                listView.empty();

                for(var i=0;i<data.length;i++){
                    if(!data[i]['gm_id'])
                        continue;

                    var group = data[i], copy = template;

                    $.each(group,function(key,value){
                        if(key=="icon")
                            value = "<img src='"+img_get({"type":"wall_60","name":value})+"' class='img-rwb' />";

                        if(key=="name" && group.gm_notification){
                            value = value+" <span class='badge-messaeg-unread'></span>";
                        }

                        copy= copy.replace(new RegExp("{{"+key+"}}", 'g'),value);

                    });
                    listView.append("<li>"+copy+"</li>");
                }
            },

            itemAvailable : function(){

                var data = WallCtrl.storage_getGroups(),
                    template = $('#template-group-listing-item').html(),
                    listView = $("#listView_group_available");

                listView.empty();

                for(var i=0;i<data.length;i++){
                    if(data[i]['gm_id'])
                        continue;

                    var group = data[i], copy = template;

                    $.each(group,function(key,value){
                        if(key=="icon")
                            value = "<img src='"+img_get({"type":"wall_60","name":value})+"' class='img-rwb' />";

                        if(key=="name" && group.gm_notifications){
                            value = value+" <span class='badge-messaeg-unread'></span>";
                        }

                        copy= copy.replace(new RegExp("{{"+key+"}}", 'g'),value);
                    });

                    listView.append("<li>"+copy+"</li>");
                }
            }
        }
    }();

    return {

        /*
        * Methods Getter/Setter for Wall Controller
        * get Public / Private Members
        * set Public / Private Members
        * */
        getModule : function(){return MODULE;},
        setModule : function(value){
            return MODULE=value;
            if(MODULE=="group" && value == "event"){
                GROUP_ID = module_id;
            }else if(MODULE=="event" && value=="group"){

            }else if(MODULE!=value){
                GROUP_ID = false;
            }

        },

        getModuleId : function(){return MODULE_ID},
        setModuleId : function(id){return MODULE_ID = parseInt(id);},

        getPostId : function(){return POST_ID},
        setPostId : function(id){return POST_ID = parseInt(id);},

        getGroupId : function(){return GROUP_ID},
        setGroupId : function(id){return GROUP_ID = parseInt(id);},

        getAdvertisementId : function(){return AD_ID;},
        setAdvertisementId : function(id){
            WallCtrl.setPostId(id);
            return AD_ID = parseInt(id);
        },

        getEventId : function(){return EVENT_ID},
        setEventId : function(id){return EVENT_ID = parseInt(id);},

        getFilter : function(){return FILTER;},
        setFilter : function(value){return FILTER = value;},

        getScroll : function(){return OFFSETS[WallCtrl.getModule()]['scroll'];},
        setScroll : function(value){return OFFSETS[WallCtrl.getModule()]['scroll']=value;},

        getFirstPostId : function(){return OFFSETS[WallCtrl.getModule()]['start'];},
        getLastPostId : function(){return OFFSETS[WallCtrl.getModule()]['last'];},

        getOffset : function(){
            return OFFSETS[WallCtrl.getModule()];
        },
        setOffset : function(time){
            time = parseInt(time);
            if(!WallCtrl.getFirstPostId() || WallCtrl.getFirstPostId() > time  ){
                OFFSETS[WallCtrl.getModule()]['start'] = time;
            }
            if(!WallCtrl.getLastPostId() || WallCtrl.getLastPostId() < time  ){
                OFFSETS[WallCtrl.getModule()]['last']=time;
            }
        },
        resetOffset : function(type){
            if(typeof type=="undefined"){
                OFFSETS = {
                    "society" : {scroll:1000,start:0,last:0},
                    "event" : {scroll:1000,start:0,last:0},
                    "group" : {scroll:1000,start:0,last:0},
                    "soshare" : {scroll:1000,start:0,last:0},
                };
            }else{
                OFFSETS['type'] = {scroll:1000,start:0,last:0};
            }
        },

        filter : function(value){
            WallCtrl.setFilter(value);
            $('[data-wall-ads]').hide();
            switch(value){
                case "all" : $('[data-wall-filter]').show(); break;
                case "survey" : $('[data-wall-filter]').hide();$('[data-wall-filter="Survey"]').show();   break;
                case "event" : $('[data-wall-filter]').hide();$('[data-wall-filter="Event"]').show();   break;
                case "offer" : $('[data-wall-filter]').hide();$('[data-wall-filter="Offer"]').show();   break;
                case "job" : $('[data-wall-filter]').hide();$('[data-wall-filter="Jobs"]').show();   break;
                case "classified" : $('[data-wall-filter]').hide();$('[data-wall-filter="Classified"]').show();   break;
                case "mypost" : $('[data-wall-filter]').hide();$('[data-wall-author="'+ProfileCtrl.getUserId()+'"]').show();   break;
            }
        },
        filterSos : function(value){
            WallCtrl.setFilter(value);
            switch(value){
                case "all" : $('[data-sos-filter]').show(); break;
                case "carpool" : $('[data-sos-filter]').hide();$('[data-sos-filter="Car Pool"]').show();   break;
                case "neighborrow" : $('[data-sos-filter]').hide();$('[data-sos-filter="NeighBorrow"]').show();   break;
                case "blood" : $('[data-sos-filter]').hide();$('[data-sos-filter="Blood Request"]').show();   break;
                case "job" : $('[data-sos-filter]').hide();$('[data-sos-filter="Jobs"]').show();   break;
                case "offer" : $('[data-sos-filter]').hide();$('[data-sos-filter="Offers"]').show();   break;
                case "sos-offers" : $('[data-sos-filter]').hide();$('[data-sos-author="'+ProfileCtrl.getUserId()+'"]').show();   break;
                case "sos-requests" : $('[data-sos-filter]').hide();$('[data-sos-isjoined="true"]').show();   break;
            }
        },


        /*
        * Methods Related to Wall Post > Society/Event/Group
        * 1) Wall > Show/Hide
        * 2) Like UnLike
        * 3) Block Unblock
        * 4) Report Spam
        * 5) Delete Wall Post
        *
        * */
        goToEditPost : function(){

            var post = WallCtrl.storage_getPost(WallCtrl.getPostId());

            if(!post || !post.hasOwnProperty('author') || post.author.id!=ProfileCtrl.getUserId()){
                Notification.toast({message:"Invalid Operation ! Please try later",alert:true});
                return false;
            }
            /* Edit Post according to type */

            switch(post.statistics.t_id){
                case "1" :$.mobile.changePage("#wall_edit_post"); break;
                case "3" :$.mobile.changePage("#wall_edit_event"); break;
                case "4" :$.mobile.changePage("#wall_edit_survey"); break;
                case "5" :$.mobile.changePage("#wall_edit_classified"); break;
                case "103" :$.mobile.changePage("#wall_edit_offer"); break;
                case "104" :$.mobile.changePage("#wall_edit_job"); break;
            }

        },

        goToDeletePost : function(){
            WallCtrl.handlerDeletePost(WallCtrl.getPostId());
        },

        goToBlockPost : function(action){
            WallCtrl.handlerManagePostStatus(WallCtrl.getPostId(),action);
        },

        handlerDeletePost  : function(id){
            var confirm = function(){
                var success = function(response){
                    Notification.toast({message:response.message,alert:true});
                    if(response.status==1){
                        $('[data-wall-post-id="'+id+'"]').remove();
                        WallCtrl.storage_removePost(id);
                        try{
                            $('[data-role="popup"]').popup("close");
                        }catch(e){
                        }
                    }
                };
                AJAX.call({
                    url : {abs:"wall/managepoststatus"},
                    data: {
                        wmodule : WallCtrl.getModule(),
                        wmodule_id : WallCtrl.getModuleId(),
                        pid : id,
                        paction:"delete",
                    },
                    success:success,
                    async:true
                });
            };
            Notification.confirm({
                message : "Do you want to delete this post ?",
                success:confirm
            });
        },

        handlerManagePostStatus  : function(id,action){

            var confirm = function(){
                var success = function(response){
                    Notification.toast({message:response.message,alert:true});
                    if(response.status==1){
                        WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),id,response.data);

                        var template = html_create_tile(response.data);


                        var selector = $('[data-wall-module="'+WallCtrl.getModule()+'"][data-wall-post-id="'+id+'"]');

                        selector.before(template);
                        selector.remove();

                        $('[data-role="popup"]').popup("close");

                    }
                };

                AJAX.call({
                    url : {abs:"wall/managepoststatus"},
                    data : {
                        wmodule : WallCtrl.getModule(),
                        wmodule_id : WallCtrl.getModuleId(),
                        pid : id,
                        paction:action,
                    },
                    async:true,
                    success:success
                });
            };

            var message = action=="active"?"Unblock":"Block";

            Notification.confirm({
                message : "Do you want "+message+" this post ?",
                success:confirm
            });
        },

        reportSpam : function(){

            var id = WallCtrl.getPostId();

            var confirm = function(){

                var success = function(response){
                    Notification.toast({message:response.message,alert:true});
                    if(response.status==1){
                        $('[data-role="popup"]').popup("close");
                    }
                };

                AJAX.call({
                    url : {abs:"wall/reportspam"},
                    data: {
                        wmodule : WallCtrl.getModule(),
                        wmodule_id : WallCtrl.getModuleId(),
                        pid : id
                    },
                    success:success,
                    async:true
                });
            };

            Notification.confirm({
                message : "Do you want to report this post ?",
                success:confirm
            });

        },

        pageShowWall: function (event ,ui,pageId) {

            Application.setPageTitle(pageId,ProfileCtrl.getUserSociety('society_name'));

            WallCtrl.setModule("society");
            WallCtrl.setModuleId(ProfileCtrl.getSocietyId());

            TemplateWall.items();

            WallCtrl.refreshWall();
        },

        refreshWall : function(){

            WallCtrl.setModule("society");

            WallCtrl.setModuleId(ProfileCtrl.getSocietyId());


            WallCtrl.service_getWallPost(TemplateWall.items);
        },

        removePost : function(pid){ /* Methods >> Remove Wall Post From DOM & Local Storage */
            WallCtrl.storage_removePost(pid);
            $('[data-sos-post-id="'+pid+'"],[data-wall-post-id="'+pid+'"]').remove();
        },

        /* Ads Wall */
        pageShowAds : function(event,ui,pageId){
            WallCtrl.service_getAds("current");
        },

        service_getAds : function(type){

            var success = function (response) {
                if (response.status) {
                    if(!response.data){
                        Notification.toast({message:"No more ads available",alert:true});
                        Application.back();
                    }else{
                        TemplateAds.item(response.data);
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };



            AJAX.call({
                url: {abs: "wall/getads"},
                data : {
                    type : type,
                    ref_id : WallCtrl.getAdvertisementId()
                },
                success: success,
                async:true
            });
        },

        /* Wall Post Detail Page */
        goToPostDetail : function(pId){
            WallCtrl.setPostId(pId);
            $.mobile.changePage("#society_wall_detail");
        },

        pageShowWallDetail : function(event,ui,pageId){
            TemplateWall.detailPage(WallCtrl.getPostId());
        },

        refreshWallDetail : function(){
            TemplateWall.detailPage(WallCtrl.getPostId());
        },

        pageHideWallDetail : function(event,ui,pageId){
            Application.setPageTitle(pageId,"");

            /* Remove Footer */
            $('#'+pageId+" [data-role='footer']").remove();
        },





        handlerLikeUnlikePosts : function(element){

            var post = $(element).parents('.card');

            var post_id  = $(post).attr('data-wall-post-id');
            var post_module  = $(post).attr('data-wall-module');
            var post_module_id  = $(post).attr('data-wall-module-id');
            var post_isLike  = $(post).attr('data-wall-isLike');

            var post_isLikeNew = post_isLike=="1" ? "0":"1";
            var current_likes = parseInt($('.like-counts-'+post_id).html());
            var new_likes = post_isLike == "0"?current_likes+1:current_likes-1;

            var beforeSend = function(){

                $('[data-wall-post-id="'+post_id+'"]').attr("data-wall-isLike",post_isLikeNew);

                $('.item-like-'+post_id).removeClass("like-"+post_isLike).addClass("like-"+post_isLikeNew);

                $('.like-counts-'+post_id).html(new_likes);

                WallCtrl.storage_setPostLikes(post_id,post_isLike=="0"?"like":"unlike");

            };

            var success = function(response){
                if(response.status){
                }else{
                    post_isLikeNew = post_isLikeNew=="1"?"0":"1";
                    $('[data-wall-post-id="'+post_id+'"]').attr("data-wall-isLike",post_isLikeNew);
                    $('.item-like-'+post_id).removeClass("like-"+post_isLike).addClass("like-"+post_isLikeNew);
                    $('.like-counts-'+post_id).html(current_likes);
                    WallCtrl.storage_setPostLikes(post_id,post_isLike=="0"?"unlink":"like");
                    Notification.toast({message:response.message,alert: true});
                }
            };

            AJAX.call({
                url : {abs:"wall/managepostlike"},
                beforeSend :beforeSend,
                async:true,
                data  :{
                    pid: post_id,
                    isLiked : post_isLike,
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId()
                },
                success:success
            });

        },

        handlerAddPostComment : function(inObject){

            $(inObject).keypress(function(e){

                var code = (e.keyCode ? e.keyCode : e.which);

                var commentString = $.trim($(inObject).val());

                if(code == 13 && commentString.length > 0){

                    var post_id = WallCtrl.getPostId();

                    var current_comments_count = parseInt($('.comment-counts-'+WallCtrl.getPostId()).html());

                    var container = $('.list.list-comment');

                    var time = new Date().getTime();

                    var temp_timestamp = post_id+"c"+time;

                    var beforeSend = function(){

                        $(inObject).val("");

                        var template = $('#template-comment-item').html();

                        var comments = [];

                        comments.push({
                            id:temp_timestamp,
                            date : "Just Now",
                            image:ProfileCtrl.getUserProfile('user_image'),
                            uid:ProfileCtrl.getUserProfile('user_id'),
                            name : ProfileCtrl.getUserProfile('user_name'),
                            content:commentString
                        });

                        var stored_post = WallCtrl.storage_getPost(WallCtrl.getPostId());

                        stored_post['statistics']['comments'] = current_comments_count+1;

                        WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),WallCtrl.getPostId(),new Array(stored_post));

                        $('.comment-counts-'+WallCtrl.getPostId()).html(current_comments_count+1);

                        $.each(comments,function(a,b){
                            $.each(b,function(c,d){

                                if(c=="image"){
                                    d = "<img src='"+IMAGE.getUrl("profile",d,"60")+"'>"
                                }
                                template = template.replace(new RegExp("{{"+c+"}}","g"),d);
                            });

                            template = template.replace(new RegExp("{{regxControl}}","g"),"");

                            container.append(template);
                        });

                        WallCtrl.storage_setPostComments(WallCtrl.getPostId());
                    };

                    var success = function(response){
                        if(response.status=="1"){
                            regxControl = "<span class='comment-control'><button data-role='none' onclick='WallCtrl.handlerDeletePostComment("+response.pc_id+")' ><i class='icon ion-ios-trash'></i> remove </button></span>";
                            $('[data-item-type="post-comment"][data-item-id="'+temp_timestamp+'"] .comment-time').append(regxControl);
                            $('[data-item-type="post-comment"][data-item-id="'+temp_timestamp+'"]').attr("data-item-id",response.pc_id);




                        }else{
                            Notification.toast({message:response.message,alert:true});
                        }
                    };

                    AJAX.call({
                        url : {abs:"wall/addcomment"},
                        data: {
                            pId:post_id,
                            wmodule:WallCtrl.getModule(),
                            wmodule_id:WallCtrl.getModuleId(),
                            comment:commentString
                        },
                        async:true,
                        beforeSend : beforeSend,
                        success: success
                    });

                    return false;
                }
            });

            $(inObject).removeAttr('onclick');
        },

        handlerEditPostComment : function(id){

        },

        handlerManagePostCommentStatus: function(){},

        handlerDeletePostComment: function(cId){

            var confirm = function(){

                var success = function(response){
                    Notification.toast({message:response.message,alert:true});
                    if(response.status==1){
                        $('[data-item-type="post-comment"][data-item-id="'+cId+'"]').remove();

                        /* Dec Comment Count */

                        current_comment_count = $('.comment-counts-'+WallCtrl.getPostId()).html();

                        if(current_comment_count){
                            current_comment_count = parseInt(current_comment_count);
                            if(current_comment_count>0){
                                current_comment_count-=1;
                            }else{
                                current_comment_count=0;
                            }
                            current_comment_count = $('.comment-counts-'+WallCtrl.getPostId()).html(current_comment_count);
                        }
                    }
                };

                AJAX.call({
                    url : {abs:"wall/deletecomment"},
                    data: {
                        wmodule : WallCtrl.getModule(),
                        wmodule_id : WallCtrl.getModuleId(),
                        pid : WallCtrl.getPostId(),
                        cid : cId,
                        paction:"delete"
                    },
                    success:success,
                    async:true
                });
            };

            Notification.confirm({
                message : "Do you want to delete this comment ?",
                success:confirm
            });

        },





        /*
         * Methods Related to SoShare Wall
         * 1) SoShare Wall > Show/Hide
         * 2) Join / Left Request
         * 3) Delete Request
         * 4) Close Request
         * 5) Approve / Reject Request
         *
         * */
        pageShowWallSoShare: function (event ,ui,pageId) {

            WallCtrl.setModule("soshare");
            WallCtrl.setModuleId(ProfileCtrl.getSocietyId());

            if(!Application.getPageShow(pageId))
                TemplateWall.items();

            WallCtrl.refreshShowWallSoShare();
        },

        refreshShowWallSoShare : function(){
            WallCtrl.setModule("soshare");
            WallCtrl.setModuleId(ProfileCtrl.getSocietyId());
            WallCtrl.service_getWallPost(TemplateWall.items);
        },

        sosPostAction : function(id,action){ /* SosWall Post Close/Delete/Left/Join */




            var confirm = function(){
                var success = function(response){
                    if(response.status){
                        Notification.toast({message:response.message,alert:true});

                        var postDetails = {
                            author : response.data.data.author,
                            post : response.data.data.post,
                            statistics : response.data.data.statistics,
                        };

                        WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),WallCtrl.getPostId(),new Array(postDetails));

                        if(postDetails.statistics.t_id=="102" && action=="join"){
                            Application.addToCalendar({
                                title : "Car Pool with "+postDetails.author.name,
                                location : postDetails.post.location.destination.address,
                                note : "Carpool from "+postDetails.post.location.source.address+" to "+postDetails.post.location.destination.address,
                                start : new Date(postDetails.post.timestamp*1000),
                                end : null,
                            });
                        }

                        TemplateWall.detailPage(WallCtrl.getPostId(),response.data.data);
                    }else{
                        Notification.toast({message:response.message,alert:true});
                    }
                };
                AJAX.call({
                    url : {abs:"wall/sospostaction"},
                    data: {
                        post_id:WallCtrl.getPostId(),
                        r_action : action,
                    },
                    async:true,
                    success:success

                });
            };

            /*
            * Close Join Left
            * */
            var label = action;
            var postData = WallCtrl.storage_getPost(WallCtrl.getPostId());

            if(postData && postData.statistics.t_id=="104"){

                switch(action){
                    case "close" : label="Close";  break;
                    case "join" : label = "Apply";  break;
                    case "left" : label = "Exit"; break;
                }
            }



            Notification.confirm({
                message : "Please confirm if you want to "+label,
                success:confirm
            });

        },

        sosRequestAction : function(id,action){/* SoShare Request [accept,reject] */



            var confirm = function(){

                var success = function(response){
                    if(response.status){
                        Notification.toast({message:response.message,alert:true});
                        var postDetails = {
                            author : response.data.data.author,
                            post : response.data.data.post,
                            statistics : response.data.data.statistics,
                        };

                        WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),WallCtrl.getPostId(),new Array(postDetails));

                        TemplateWall.detailPage(WallCtrl.getPostId(),response.data.data);
                    }else{
                        Notification.toast({message:response.message,alert:true});
                    }
                };

                AJAX.call({
                    url : {abs:"wall/sosrequestaction"},
                    data: {
                        post_id:WallCtrl.getPostId(),
                        sos_request_id:id,
                        r_action:action,
                    },
                    async:true,
                    success:success

                });
            };

            Notification.confirm({
                message : "Please confirm if you want to "+action,
                success:confirm
            });

        },

        pageInitAddCarPool : function(event,ui,pageId){
            GOOGLE.setAutoComplete({
                selector : {
                    input : "#wall_add_car_pool #destination",
                    lat : "#wall_add_car_pool #destination_lat",
                    lng : "#wall_add_car_pool #destination_lng",
                }
            });

            GOOGLE.setAutoComplete({
                selector : {
                    input : "#wall_add_car_pool #source",
                    lat : "#wall_add_car_pool #source_lat",
                    lng : "#wall_add_car_pool #source_lng",
                }
            });


        },

        pageInitEditCarPool : function(event,ui,pageId){
            GOOGLE.setAutoComplete({
                selector : {
                    input : "#wall_edit_car_pool #car_pool_destination",
                    lat : "#wall_edit_car_pool #car_pool_destination_lat",
                    lng : "#wall_edit_car_pool #car_pool_destination_lng",
                }
            });
        },




        /*
        * Methods Related to Event
        * 1 ) Event Wall > Show/Hide
        * 2 ) eventAction > Join / Left
        *
        * */
        goToEventWall : function(id){
            WallCtrl.setEventId(id);
            WallCtrl.setPostId(id);
            var postData = WallCtrl.storage_getPost(id);
            if(postData && postData.post.joined){
                $.mobile.changePage("#event_wall");
            }else{
                $.mobile.changePage("#society_event_information");
            }
        },

        pageShowEventWall: function (event ,ui,pageId){
            WallCtrl.setModule("event");
            WallCtrl.setModuleId(WallCtrl.getEventId());
            WallCtrl.resetOffset("event");

            var eventInfo = WallCtrl.storage_getPost(WallCtrl.getEventId());

            Application.setPageTitle(pageId,eventInfo.post?eventInfo.post.title:"Event Wall");

            var template = $('#template-event-wall-info').html();


            var slider = IMAGE.createGallery(eventInfo.post.gallery);


            template = template.replace("{{title}}",eventInfo.post.title)
                .replace(new RegExp("{{gallery_html}}","g"),slider.html)
                .replace("{{start_time}}",DATE.getFromUnix(eventInfo.post.start,"h:i"))
                .replace("{{start_date}}",DATE.getFromUnix(eventInfo.post.start,"d-M-Y"))
                .replace("{{end_time}}",DATE.getFromUnix(eventInfo.post.end,"h:i"))
                .replace("{{end_date}}",DATE.getFromUnix(eventInfo.post.end,"d-M-Y"))
                .replace("{{description}}",eventInfo.post.description)
                .replace("{{location}}",eventInfo.post.location);

            //$('#society_event_wall .event-wall-detail-section').prepend(template);

            //IMAGE.initSwiper({time:slider.time});



            $('#event_wall .header .col-right').html('<a href="#society_event_information"><i class="fa icon ion-information-circled"></i></a>');

            TemplateWall.items();
            WallCtrl.refreshEventWall();
        },

        refreshEventWall : function(){
            WallCtrl.setModule("event");
            WallCtrl.setModuleId(WallCtrl.getEventId());
            WallCtrl.service_getWallPost(TemplateWall.items);
        },

        pageHideEventWall : function(event,ui,pageId){
            Application.setPageTitle(pageId,"");
            WallCtrl.resetOffset('event');
            $('#event_wall #event_wall_content').empty();
        },

        pageShowEventInformation : function(event,ui,pageId){
            TemplateWall.showEventInfo(WallCtrl.getEventId());
        },

        pageHideEventInformation : function(event,ui,pageId){},

        eventAction : function(eid,action){
            var success = function(response){
                if(response.status){
                    Notification.toast({message:response.message,alert:true});

                    WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),WallCtrl.getPostId(),new Array(response.data));

                    if(action=="join"){

                            var postDetails = response.data;

                            Application.addToCalendar({
                                title : "Event "+postDetails.post.title,
                                location : postDetails.post.location,
                                note : postDetails.post.description,
                                start : new Date(postDetails.post.start*1000),
                                end : new Date(postDetails.post.end*1000),
                            });
                    }

                    $.mobile.changePage("#society_wall");
                }else{
                    WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),WallCtrl.getPostId(),new Array(response.data));
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url : {abs:"wall/eventmanagestatus"},
                data : {
                    event_id : WallCtrl.getEventId(),
                    status:action
                },
                success:success,
                async:true
            });
        },


        /*
         * Methods Related to Groups
         * 1 ) Group Wall > Show/Hide
         * 2 ) groupAction > Join / Left
         *
         * */
        getCountJoinedGroup : function(){
            var counter = 0;
            var data = WallCtrl.storage_getGroups();

            if(!data)
                return 0;

            for(var i=0;i<data.length;i++)
                if(data[i]['gm_id'])
                    counter++;

            return counter;
        },


        pageShowGroupJoined : function(event,ui,page_id){

            if(!Application.getPageShow(page_id)){
                TemplateGroup.itemJoined();
            }
        },

        refreshGroupJoined : function(){
            WallCtrl.service_getGroups(TemplateGroup.itemJoined);
        },

        pageShowGroupAvailable : function(event,ui,page_id){
            if(WallCtrl.storage_getGroups()){
                TemplateGroup.itemAvailable();
            }
        },

        refreshGroupAvailable : function(){
            WallCtrl.service_getGroups(TemplateGroup.itemAvailable);
        },

        goToGroupWall : function(id){
            WallCtrl.setGroupId(id);
            var data = WallCtrl.storage_getGroup(id);
            if(data.gm_id){
                $.mobile.changePage("#group_wall");
            }else{
                $.mobile.changePage("#society_group_information");
            }
        },

        pageShowGroupWall: function (event ,ui,pageId){
            WallCtrl.setModule("group");
            WallCtrl.setModuleId(WallCtrl.getGroupId());
            WallCtrl.resetOffset("group");

            var groupInfo = WallCtrl.storage_getGroup(WallCtrl.getGroupId());

            Application.setPageTitle(pageId,groupInfo.name);

            /* Manage Icon */
            $('#group_wall .header .col-right').html('<a href="#society_group_information"><i class="fa icon ion-information-circled"></i></a>');


            TemplateWall.items();
            WallCtrl.refreshGroupWall();
        },

        refreshGroupWall : function(){
            WallCtrl.setModule("group");
            WallCtrl.setModuleId(WallCtrl.getGroupId());
            WallCtrl.service_getWallPost(TemplateWall.items);
        },

        pageHideGroupWall : function(event,ui,pageId){
            Application.setPageTitle(pageId,"");
            WallCtrl.resetOffset('group');
            GROUP_NEWS_COUNTER = 0;
            var gId = WallCtrl.getGroupId();
            $('a[data-item-type="group"][data-item-id="'+gId+'"] .badge-messaeg-unread').remove();
            WallCtrl.storage_resetGroupsBadge(gId);
            $('#group_wall #group_wall_content').empty();
        },

        pageHideGroupAvailable : function(event,ui,pageId){
            $('#group_available a[data-item-type="group"] .badge-messaeg-unread').remove();
            WallCtrl.storage_resetGroupsBadge();
        },




        pageShowGroupInformation : function(event,ui,pageId){
            TemplateWall.showGroupInfo(WallCtrl.getGroupId());
        },

        pageHideGroupInformation : function(event,ui,pageId){

            Application.setPageTitle(pageId,"");
            /* Remove Footer */
            $("#"+pageId+" [data-role='footer']").remove();

        },

        /* Show Members */
        getMemberForGroup : function(element){


            var pageId = Application.getActivePage();

            var container = $("#"+pageId+" .group-private-members-list");

            container.empty();

            if(element.value=="public"){
                return true;
            }


            var members = MemberCtrl.storage_getMembers();
            var connectedMembers = [];

            for(var i= 0,member;member=members[i];i++){
                if(ProfileCtrl.getUserSociety('role')!="admin")
                    if(!(member['r_receive_status']=="approved" || member['r_sent_status']=="approved"))
                        continue;
                connectedMembers.push(member);
            }

            if(connectedMembers.length==0){
                Notification.toast({message:"Not Connected with any member ! You can only add connected members to a private group"});
                element.value = "public";
                return false;
            }


            for(i=0;member = connectedMembers[i];i++){
                var template = $('#template-group-add-list-item').html();
                $.each(member,function(c,d){
                    if(c=="image"){d= 'src="'+IMAGE.getUrl("profile",d,"60")+'"';}
                    if(c=="rating"){d= getMemberRating(d)}
                    template = template.replace(new RegExp("{{"+c+"}}","g"),d);
                });
                container.append(template);
            }

            $($.mobile.activePage).trigger('create');
        },



        groupAction : function(gid,action){
            if(action=="left"){
                WallCtrl.groupActionLeft(gid,action);
            }else{
                WallCtrl.groupActionJoin(gid,action);
            }
        },

        groupActionLeft : function(gid,action){

            var confirm = function(){
                var success = function(response){
                    if(response.status){
                        Notification.toast({message:response.message,alert:true});
                        WallCtrl.storage_setGroup(WallCtrl.getGroupId(),response.data);
                        Application.setPageShow("group_joined",0);
                        Application.setPageShow("group_available",0);
                        WallCtrl.pageShowGroupInformation({},{},"society_group_information");
                    }else{
                        Notification.toast({message:response.message,alert:true});
                    }
                };

                AJAX.call({
                    url : {abs:"wall/leftgroup"},
                    data : {
                        group_id:gid,
                        status:action
                    },
                    success:success,
                    async:true
                });
            };

            Notification.confirm({
                message : "Please confirm if you want to exit from group ?",
                success:confirm
            });
        },

        groupActionJoin: function(gid,action){
            var success = function(response){
                if(response.status){
                    Notification.toast({message:response.message,alert:true});
                    WallCtrl.storage_setGroup(WallCtrl.getGroupId(),response.data);
                    Application.setPageShow("group_joined",0);
                    Application.setPageShow("group_available",0);
                    WallCtrl.pageShowGroupInformation({},{},"society_group_information");
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url : {abs:"wall/joingroup"},
                data : {
                    group_id:gid,
                    status:action
                },
                success:success,
                async:true
            });
        },


        /*
        * Methods related to Storage
        * Wall Post > get/set/delete
        * */
        storage_setPosts : function(data){

            var wall_posts = JSON.parse(localStorage.getItem("WALL_POSTS"));

            if(!(wall_posts && typeof wall_posts=="object")){
                wall_posts = {};
            }

            for(i=0;i<data.length;i++){
                wall_posts[data[i]['statistics']['id']] = data[i];
            }

            localStorage.setItem("WALL_POSTS",JSON.stringify(wall_posts));
            return true;

        },

        storage_getPosts : function(m,mid){
            var wall_posts = JSON.parse(localStorage.getItem("WALL_POSTS"));

            if(!wall_posts){
                return {};
            }

            var modules = {
                "society" : ["society","personal","group","event"],
                "soshare" : ["soshare"],
                "group" : ["group"],
                "event" : ["event"]
            };

            var out = {};

            try{
                $.each(wall_posts,function(a,b){
                    var type_id = parseInt(b['statistics']['t_id']);
                    if(m=="society" && (parseInt(b['statistics']['t_id']) <100 || parseInt(b['statistics']['t_id'])>200) ){
                        out[a]=b;
                    }else if(b['statistics']['m_id'] == mid && modules[m].indexOf(b['statistics']['m'])!=-1){
                        out[a]=b;
                    }
                });
            }catch(e){

            }
            return out;
        },

        storage_getPost : function(pid){
            var wall_posts = JSON.parse(localStorage.getItem("WALL_POSTS"));

            if(wall_posts.hasOwnProperty(pid))
                return  wall_posts[pid];

            return false;
        },

        storage_setPost : function(m,mid,pid,data){
            var posts = WallCtrl.storage_getPosts(m,mid);
            if(posts.hasOwnProperty(pid)){
                posts[pid]=data[0];
                localStorage.setItem("WALL_POSTS",JSON.stringify(posts));
                //WallCtrl.storage_setPosts(posts);
                return true;
            }

            return false;
        },

        storage_removePost : function(pid){

            var posts = JSON.parse(localStorage.getItem("WALL_POSTS"));

            if(posts.hasOwnProperty(pid)){
                delete posts[pid];
                localStorage.setItem("WALL_POSTS",JSON.stringify(posts));
                return true;
            }

            return false;

        },

        storage_setPostLikes : function(pid,type){
            var posts = JSON.parse(localStorage.getItem("WALL_POSTS"));

            if(posts.hasOwnProperty(pid)){
                if(type=="like"){
                    posts[pid].statistics.is_like = 1;
                    posts[pid].statistics.likes =  parseInt(posts[pid].statistics.likes) + 1;
                }else{
                    posts[pid].statistics.is_like = 0;
                    posts[pid].statistics.likes =  parseInt(posts[pid].statistics.likes) - 1;
                }
                localStorage.setItem("WALL_POSTS",JSON.stringify(posts));
                return true;
            }
            return false;
        },

        storage_setPostComments : function(pid){
            var posts = JSON.parse(localStorage.getItem("WALL_POSTS"));
            if(posts.hasOwnProperty(pid)){
                posts[pid].statistics.comments =  parseInt(posts[pid].statistics.comments) + 1;
                localStorage.setItem("WALL_POSTS",JSON.stringify(posts));
                return true;
            }
            return false;
        },

        storage_setGroups : function(data){return localStorage.setItem("WALL_GROUPS",JSON.stringify(data));},

        storage_getGroups : function(){return JSON.parse(localStorage.getItem("WALL_GROUPS"));},

        storage_resetGroupsBadge : function(id){
            var groups = WallCtrl.storage_getGroups();
            for(var i= 0,group;group=groups[i];i++){
                if(typeof id!="undefined" && id!=group.id)
                    continue;
                groups[i].gm_notifications = 0;
            }
            WallCtrl.storage_setGroups(groups);
        },


        storage_getGroup : function(id){
            var data = WallCtrl.storage_getGroups();

            if(!data)
                return null;

            for(i=0;i<data.length;i++)
                if(data[i]['id']==id)
                    return data[i];

            return null;
        },

        storage_setGroup : function(id,value){
            var data = WallCtrl.storage_getGroups();
            if(!data)
                data = [value];

            for(i=0;i<data.length;i++)
                if(data[i]['id']==id)
                    data[i]=value;

            WallCtrl.storage_setGroups(data);
            return true;
        },






        /*
        * Methods Related to Services
        * 1 ) getWall Post
        * 2 ) get Post Details
        * */
        service_getWallPost : function(callBack){
            var success = function (response) {
                if (response.status) {
                    if(typeof callBack=="function"){
                        WallCtrl.storage_setPosts(response.data);
                        callBack(response.data);
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };
            AJAX.call({
                url: {abs: "wall/getpost"},
                data : {
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId(),
                    start: WallCtrl.getFirstPostId(),
                    last: WallCtrl.getLastPostId()
                },
                beforeSend : function(){},
                success: success,
                async:true
            });
        },

        service_getWallPostDetail : function(callBack){

            var success = function (response) {
                if (response.status){
                    /* Update Post Data to Table */
                    var postDetails = {
                        author : response.data.author,
                        post : response.data.post,
                        statistics : response.data.statistics,
                    };

                    WallCtrl.storage_setPost(WallCtrl.getModule(),WallCtrl.getModuleId(),WallCtrl.getPostId(),new Array(postDetails));

                    if(typeof callBack=="function"){
                        callBack(response.data);
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                    /* Delete or Remove Post From Local Storage*/
                    WallCtrl.removePost(WallCtrl.getPostId());
                    Application.back();
                }
            };

            AJAX.call({
                url: {abs: "wall/getpostdetail"},
                data : {
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId(),
                    pid : WallCtrl.getPostId()
                },
                success: success,
                async:true
            });
        },

        service_getGroups : function(callBack){

            var success = function (response){
                if (response.status) {
                    WallCtrl.storage_setGroups(response.data);
                    if(typeof callBack=="function"){
                        callBack();
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };


            AJAX.call({
                url: {abs: "wall/getgroups"},
                success: success,
                async:true
            });
        },

        service_getGroupDetails : function(callBack){

            var success = function (response) {
                if (response.status) {
                    if(typeof callBack=="function"){
                        callBack(response.data);
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs: "wall/getgroupdetails/group_id/"+WallCtrl.getGroupId()},
                success: success,
                async:true
            });
        },

        service_getGroupDetailsEdit : function(callBack){

            var success = function (response) {
                if (response.status) {
                    if(typeof callBack=="function"){
                        callBack(response.data);
                    }
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs: "wall/geteditgroupdetails"},
                data : {
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId(),
                    filter : WallCtrl.getFilter()
                },
                success: success,
                async:true
            });
        },

        refreshNews : function(callBack){

            var topic = ProfileCtrl.getUserSociety('society_keywords');

            var feedUrl =  "https://news.google.com/news/feeds?pz=1&cf=all&ned=uk&hl=en&q="+topic+"&output=rss";

            var newsUrl = "http://ajax.googleapis.com/ajax/services/feed/load?v=1.0&num=20&callback=?&q="+encodeURIComponent(feedUrl);

            $.ajax({
                url : newsUrl,
                dataType : 'json',
                success  : function (data) {
                    var allItem = [];
                    if(data.responseData && data.responseData.feed && data.responseData.feed.entries){
                        $.each(data.responseData.feed.entries, function (i,e){
                            var link = e.link.split("&url=");
                            var regex = /<img.*?src="(.*?)"/;
                            var src = regex.exec(e.content);
                            if(src){src = src[1];}else{src="img/default/default.png"}
                            allItem.push({
                                src : src,
                                title: e.title,
                                link : link[1],
                                description: e.contentSnippet
                            });
                        });
                    }
                    STORAGE.setNews(allItem);
                    if(typeof callBack=="function"){
                        callBack();
                    }
                }
            });
        },

        refreshGroupNews : function(callBack){

            var pageId = Application.getActivePage();

            if(pageId!="group_wall")
                return ;

            var group = WallCtrl.storage_getGroup(WallCtrl.getGroupId());

            if(!group || !group.keywords)
                return false;

            var topic = group.keywords;

            var feedUrl =  "https://news.google.com/news/feeds?pz=1&cf=all&ned=uk&hl=en&q="+topic+"&output=rss";
            var newsUrl = "http://ajax.googleapis.com/ajax/services/feed/load?v=1.0&num=20&callback=?&q="+encodeURIComponent(feedUrl);

            $.ajax({
                url : newsUrl,
                dataType : 'json',
                success  : function (data) {
                    var allItem = [];
                    if(data.responseData && data.responseData.feed && data.responseData.feed.entries){
                        $.each(data.responseData.feed.entries, function (i,e){
                            var link = e.link.split("&url=");
                            var regex = /<img.*?src="(.*?)"/;
                            var src = regex.exec(e.content);
                            if(src){src = src[1];}else{src="img/default/default.png"}
                            allItem.push({
                                src : src,
                                title: e.title,
                                link : link[1],
                                description: e.contentSnippet
                            });
                        });
                    }
                    STORAGE.setGroupNews(group.id,allItem);
                    if(typeof callBack=="function"){
                        callBack();
                    }
                }
            });
        },


        /* Methods Related to Populate Edit Forms
        * 1) populatePost
        * 2) populateClassified
        * 3) populateEvent
        * 4) populateSurvey
        * 5) populateGroup
        * */
        pageShowEditGroup : function(event,ui){

            WallCtrl.service_getGroupDetailsEdit(html_create_edit_group);

        },

        pageShowEditPost : function(event,ui){

            var pageId = Application.getActivePage();

            var pageConfigs = Application.getPageConfig(pageId);

            if(pageConfigs["view"].hasOwnProperty("form") && pageConfigs["view"]["form"]){

                var formConfig = pageConfigs["view"]["form"];

                var post = WallCtrl.storage_getPost(WallCtrl.getPostId());


                if(post && post.post){
                    var data = post.post;
                    if(formConfig.id=="frm_wall_edit_post"){data.status = data.description;}
                    $.each($("#"+formConfig.id).find(':input'),function(index,value){
                        if(value.type!='file' && data.hasOwnProperty(value.name)){
                            if(formConfig.id=="frm_edit_wall_event" && ["start","end"].indexOf(value.name)!=-1){
                                value.value = DATE.getFromUnix(data[value.name],'h:i d-M-Y');
                            }else{
                                value.value = data[value.name];
                            }
                            if(value.type=="select-one")
                                $(value).selectmenu('refresh', true);
                        }
                    });
                }
            }
        },

        pageShowEditEvent : function(event,ui){
            var post = WallCtrl.storage_getPost(WallCtrl.getPostId());

            $("#wall_edit_event #event_title").val(post.post.title);
            $("#wall_edit_event #event_start_datetime").val(DATE.getFromUnix(post.post.start,"h:i d-M-Y"));
            $("#wall_edit_event #event_end_datetime").val(DATE.getFromUnix(post.post.e,"h:i d-M-Y"));
            $("#wall_edit_event #event_location").val(post.post.location);
            $("#wall_edit_event #event_contact_details").val(post.post.contact);
            $("#wall_edit_event #event_description").val(post.post.description);
        },

        pageShowEditSurvey : function(event,ui){

            var post = WallCtrl.storage_getPost(WallCtrl.getPostId());

            $("#wall_edit_survey #survey_ans_type option[value='"+post.post.ans_type+"']").attr('selected', 'selected');
            $('#wall_edit_survey #survey_ans_type').selectmenu('refresh', true);

            $("#wall_edit_survey #survey_question").val(post.post.question);

            var options = JSON.parse(post.post.options);

            $.each(options,function(a,b){$("#wall_edit_survey #"+a).val(b);});


        },

        pageShowEditClassified : function(event,ui){
            var post = WallCtrl.storage_getPost(WallCtrl.getPostId());
            $("#wall_edit_classified #classified_category").val(post.post.category_name);
            $('#wall_edit_classified #classified_category').selectmenu('refresh');
            $("#wall_edit_classified #classified_title").val(post.post.title);
            $("#wall_edit_classified #classified_price").val(post.post.price);
            $("#wall_edit_classified #classified_description").val(post.post.description);
        },

        pageShowEditJob : function(event,ui){
            var post = WallCtrl.storage_getPost(WallCtrl.getPostId());
            $("#wall_edit_job #job_title").val(post.post.title);
            $("#wall_edit_job #job_experience").val(3);
            $('#wall_edit_job #job_experience').selectmenu('refresh');

            $("#wall_edit_job #job_type").val(post.post.type);
            $('#wall_edit_job #job_description').val(post.post.description);
            $('#wall_edit_job #job_company_name').val(post.post.company_name);
            $('#wall_edit_job #job_company_website').val(post.post.company_website);
            $('#wall_edit_job #job_company_contact').val(post.post.company_contact);
            $('#wall_edit_job #job_company_description').val(post.post.company_description);
        },

        pageShowEditOffer : function(event,ui){
            var post = WallCtrl.storage_getPost(WallCtrl.getPostId());
            $("#wall_edit_offer #rent_category_name").val(post.post.category);
            $('#wall_edit_offer #rent_category_name').selectmenu('refresh');
            $('#wall_edit_offer  #rent_title').val(post.post.title);
            $('#wall_edit_offer  #rent_description').val(post.post.description);
        },

        sync_wall : function(){ DATE.getFromUnix();

            var wall_posts = JSON.parse(localStorage.getItem("WALL_POSTS"));

            if(wall_posts){
                var ids = [];
                $.each(wall_posts,function(i,k){
                    ids.push(k['statistics']['id']);
                });

                var success = function(response){
                    if(response.status){
                        var id_delete = response.data;
                        for(var i=0,id;id = id_delete[i];i++){
                            WallCtrl.storage_removePost(id);
                            /* Remove from Wall if exists */
                            $('[data-wall-post-id="'+id+'"]').remove();
                            $('[data-sos-post-id="'+id+'"]').remove();
                        }
                    }
                };

                AJAX.call({
                    url : {abs:"wall/sync"},
                    data : {
                        ids:ids.join(","),
                        uat_device_type : AppDevice.getPlatform(),
                        uat_device_name : AppDevice.getModel(),
                        uat_app_version : AppDevice.getAppVersion(),
                        uat_version_code : AppDevice.getAppBuild(),
                        uat_push_token : PushCtrl.getRegistrationId()
                    },
                    async:true,
                    beforeSend : function(){},
                    success : success
                });
            }

        },

        share_post : function(){

            $.mobile.loading('show');

            var post = WallCtrl.storage_getPost(WallCtrl.getPostId());

            var options = {
                chooserTitle: 'Pick an app' // Android only, you can override the default share sheet title
                //message: 'This is the testing testing for the testing of the testing option message', // not supported on some apps (Facebook, Instagram)
                //subject: 'This is the testing message for the tesitng of the tesing site', // fi. for email
                //files: ['http://192.168.1.99/cordova/Projects/societo@NearByMoms/website/public/resources/profile_images//60/9275-1461577509-82014.jpg'], // an array // of filenames either locally or remotely
                /*url: 'http://www.societo.in',*/
            };

            switch(post.statistics.t_id){
                case "1" :

                    if(post.post.description){
                        options.message = post.post.description?post.post.description:"";
                    }else{
                        options.message = "";
                    }

                    if(post.post.gallery){
                        var images = JSON.parse(post.post.gallery);
                        if(typeof images=='object' && images.length>0){
                            options.files = [];
                            for(var i=0;i<images.length;i++){
                                options.files.push(IMAGE.getUrl('wall',images[i],"300"));
                            }
                        }
                    }

                    options.message+="\n\n (Wall Post at Societo. Download app http://bit.ly/21aJxqy)";

                    break;/*post*/
                case "3" :
                    options.message = "New Event \n\n"+post.post.title+"\nFrom "+DATE.getFromUnix(post.post.start,"h:i d-M-Y")+" to "+DATE.getFromUnix(post.post.end,"h:i d-M-Y")+" \n\nDetails\nLocation : "+post.post.location+"\nContact : "+post.post.contact_details+"\n\n"+post.post.description;
                    if(post.post.gallery){
                        var images = JSON.parse(post.post.gallery);
                        if(typeof images=='object' && images.length>0){
                            options.files = [];
                            for(var i=0;i<images.length;i++){
                                options.files.push(IMAGE.getUrl('wall',images[i],"300"));
                            }
                        }
                    }
                    options.message+="\n\n(Post Events at Societo. Download app http://bit.ly/21aJxqy )";
                    break;/*event*/
                case "4" :
                    options.message = "Survey \n\n "+post.post.question;
                    options.message+="\n\n(Post new survey at Societo. Download app http://bit.ly/21aJxqy )"
                    break;/*survey*/
                case "5" :
                    options.message = "Classified  "+post.post.category_name+" >  "+post.post.title+"\n "+post.post.description;
                    if(post.post.gallery){
                        var images = JSON.parse(post.post.gallery);
                        if(typeof images=='object' && images.length>0){
                            options.files = [];
                            for(var i=0;i<images.length;i++){
                                options.files.push(IMAGE.getUrl('wall',images[i],"300"));
                            }
                        }
                    }
                    options.message+="\n\n(Post Classifieds at Societo. Download app http://bit.ly/21aJxqy )";
                    break;/*classified*/
                case "101" :
                    options.message = "⁠⁠⁠Blood Request for blood group "+post.post.type+" \n\nContact Details\n"+post.post.contact_person+" ("+post.post.contact_no+") "+"\n\nNotes\n"+post.post.contact_person.message;
                    options.message+="\n\n(Now find Blood Donors within your neighborhood at Societo. Download app http://bit.ly/21aJxqy) ";
                    break;/*blood*/
                case "102" :
                    options.message = "Carpool\nFrom "+post.post.location.source.address+" to "+post.post.location.destination.address+" on "+post.post.date;
                    options.message+="\nAvailable Seats -"+(parseInt(post.post.seat_share)-parseInt(post.post.seat_booked));
                    options.message+="\n\n(Smart Carpool at Societo, Download App http://bit.ly/21aJxqy )";
                    break;/*carpool*/
                case "103" :
                    options.message = "⁠⁠⁠SoShare NeighBorrow   "+post.post.category_name+" >  "+post.post.title+"\n "+post.post.description;
                    if(post.post.gallery){
                        var images = JSON.parse(post.post.gallery);
                        if(typeof images=='object' && images.length>0){
                            options.files = [];
                            for(var i=0;i<images.length;i++){
                                options.files.push(IMAGE.getUrl('wall',images[i],"300"));
                            }
                        }
                    }
                    options.message+="\n\n(Now borrow from neighbors at Societo. Download app http://bit.ly/21aJxqy )";
                    break;/*neightborrow*/
                case "105" :
                    options.message = "SoShare offer  \n\n"+post.post.title+"\n"+post.post.category_name+"\n\n "+post.post.description;
                    if(post.post.gallery){
                        var images = JSON.parse(post.post.gallery);
                        if(typeof images=='object' && images.length>0){
                            options.files = [];
                            for(var i=0;i<images.length;i++){
                                options.files.push(IMAGE.getUrl('wall',images[i],"300"));
                            }
                        }
                    }
                    options.message+="\n\n(Offers from neighbors at Societo. Download app http://bit.ly/21aJxqy )";
                    break;/*offers*/
                case "1001" : break;/*ads*/

            }

            if(!options.message){
                options.message="";

            }

            var onSuccess = function(result) {
                $.mobile.loading('hide');
            };

            var onError = function(msg) {
                $.mobile.loading('hide');
            };

            try{
                window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
            }catch(e){
                $.mobile.loading('hide');
            }
        },

        onSubmitAddGroup: function (inObject) {

            var $form = $(inObject);

            var success = function (response) {
                if (response.status) {
                    Notification.toast({message:response.message,alert:true});
                    WallCtrl.service_getGroups(TemplateGroup.joined);
                    WallCtrl.refreshGroupJoined();
                    Application.back();
                } else {
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs:$form.attr('action')},
                data: {
                    data : $form.serialize(),
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId()
                },
                async:true,
                success: success
            });

        },
        onSubmitEditGroup: function (inObject) {

            var $form = $(inObject);

            var success = function (response) {
                if (response.status) {
                    Notification.toast({message:response.message,alert:true});
                    WallCtrl.service_getGroups(TemplateGroup.joined);
                    WallCtrl.refreshGroupJoined();
                    Application.back();
                } else {
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs:$form.attr('action')+"/gid/"+WallCtrl.getGroupId()},
                data: {
                    data : $form.serialize(),
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId()
                },
                async:true,
                success: success
            });

        },

        onSubmitAddPost: function (inObject) {

            var $form = $(inObject);

            var isEmpty = true;
            var values_array = $form.serializeArray();

            for(i=0;i<values_array.length;i++){
                if(values_array[i]['value']!=""){
                    isEmpty = false;
                }
            }

            if(isEmpty){
                Notification.toast({message:"Please share something ! Form is empty",alert:true});
                return false;
            }

            var success = function (response) {
                if (response.status) {
                    Notification.toast({message:response.message,alert:true});
                    WallCtrl.storage_setPosts(new Array(response.data));
                    TemplateWall.items(new Array(response.data));


                    /* Save Dates if Event */
                    if($form.attr('id')=="frm_add_wall_event"){
                        var postDetails = response.data;

                        Application.addToCalendar({
                            title : "Event "+postDetails.post.title,
                            location : postDetails.post.location,
                            note : postDetails.post.description,
                            start : new Date(postDetails.post.start*1000),
                            end : new Date(postDetails.post.end*1000),
                        });

                    }



                    Application.back();
                } else {
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs: $form.attr('action')},
                data: {
                    data : $form.serialize(),
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId()
                },
                async:true,
                success: success
            });
        },
        onSubmitEditPost: function (inObject) {

            var $form = $(inObject);

            var isEmpty = true;
            var values_array = $form.serializeArray();

            for(i=0;i<values_array.length;i++){
                if(values_array[i]['value']!=""){
                    isEmpty = false;
                }
            }

            if(isEmpty){
                Notification.toast({message:"Please share something ! Form is empty",alert:true});
                return false;
            }

            var success = function (response) {
                if (response.status) {
                    Notification.toast({message:response.message,alert:true});
                    WallCtrl.storage_setPosts(new Array(response.data));
                    TemplateWall.items(new Array(response.data));
                    Application.back();
                } else {
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs: $form.attr('action')+"/postTypeId/"+WallCtrl.getPostId()},
                data: {
                    data : $form.serialize(),
                    wmodule : WallCtrl.getModule(),
                    wmodule_id : WallCtrl.getModuleId()
                },
                async:true,
                success: success
            });
        },

        onSubmitAdReview: function (inObject) {

            var $form = $(inObject);

            var val_1 = $("#advertisement_detail #uar_ans_1").val();
            var val_2 = $("#advertisement_detail #uar_ans_2").val();
            var val_3 = $("#advertisement_detail #uar_ans_3").val();
            var val_4 = $("#advertisement_detail #uar_ans_4").val();

            if(!val_1 ||  !val_2 || !val_3 || !val_4){
                Notification.toast({message:"Please rate all categories",alert:true});
                return false ;
            }

            var success = function (response) {
                if (response.status) {
                    Notification.toast({message:response.message,alert:true});
                    Application.setPageShow('profile_points',-1);
                    WallCtrl.service_getAds('next');
                } else {
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url: {abs: "wall/reviewadd/pid/"+WallCtrl.getAdvertisementId()},
                data: {data : $form.serialize()},
                async:true,
                success: success
            });
        },

        handlerSurveySubmit : function(){

        },

        attendSurvey : function(form){

            if($(form).serialize()==""){
                Notification.toast({message:"Please select your choice",alert:true});
                return false;
            }

            var success = function(response){
                if(response.status){
                    WallCtrl.storage_setPosts(new Array(response.data));
                    TemplateWall.items(new Array(response.data));
                    Notification.toast({message:response.message,alert:true});
                }else{
                    Notification.toast({message:response.message,alert:true});
                }
            };

            AJAX.call({
                url : {abs:"wall/attendsurvey"},
                data : {
                    data : $(form).serialize(),
                    pid :$(form).attr('data-post-id'),
                },
                async:true,
                success:success
            });

            return false;
        },

        attendRating : function(form){

            if($(form).serialize()==""){
                Notification.toast({message:"Please Add Rating",alert:true});
                return false;
            }

            var success = function(response){
                Notification.toast({message:response.message,alert:true});
                if(response.status){
                    $('[data-wall-post-id="'+$(form).attr('data-post-id')+'"]').remove();
                    WallCtrl.storage_removePost($(form).attr('data-post-id'));
                }
            };

            AJAX.call({
                url : {abs:"wall/attendrating"},
                data : {
                    data : $(form).serialize(),
                    pid :$(form).attr('data-post-id'),
                },
                async:true,
                success:success
            });

            return false;
        },

        /*
        * Methods Other
        * [Other methods related to WallController]
        * */
        onChangeMatType : function(objSelect){
            var lookingFor = objSelect.value=="bride" ? "Groom" : "Bride";
            $("#"+Application.getActivePage()+' #span-looking-for').html(lookingFor);
        },

    }
}();